SystemOrganization addCategory: #'System-Settings-Core'!
SystemOrganization addCategory: #'System-Settings-Morphic'!
SystemOrganization addCategory: #'System-Settings-Pragma'!
SystemOrganization addCategory: #'System-Settings-Browser'!
SystemOrganization addCategory: #'System-Settings-Style'!
SystemOrganization addCategory: #'System-Settings-Menu-Core'!
SystemOrganization addCategory: #'System-Settings-Menu-Assembler'!
SystemOrganization addCategory: #'System-Settings-Menu-Browser'!

ListItemWrapper subclass: #SettingTreeNode
	instanceVariableNames: 'parentNode contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

!SettingTreeNode methodsFor: 'comparing' stamp: 'alain.plantec 3/3/2009 22:46'!
<= other
	^ self asString <= other asString! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 20:56'!
asString
	^ self item value asString! !

!SettingTreeNode methodsFor: 'menu' stamp: 'alain.plantec 3/23/2009 10:11'!
browseDeclaration
	self item browseDeclaration! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 21:10'!
buildContents
	| ct |
	ct := self model
				orderedContentsFrom: (self childrenItems
						collect: [:d | self model nodeClass with: d model: self model]).
	ct
		do: [:c | 
			c parentNode: self.
			c buildContents].
	^ ct! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 11:55'!
childrenItems
	^ (self model childrenOf: self item) 
! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 08:53'!
contents
	^ contents ifNil: [contents := self buildContents ]
	! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 3/16/2009 22:07'!
description
	^ self item description! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 10:00'!
icon
	^ self item value ifNotNil: [:v | v icon]! !

!SettingTreeNode methodsFor: 'testing' stamp: 'alain.plantec 3/17/2009 09:45'!
isEmpty
	^ self contents isEmpty! !

!SettingTreeNode methodsFor: 'menu' stamp: 'alain.plantec 3/24/2009 21:26'!
keyStroke: aCharacter from: aTreeMorph 
	aCharacter = $b
		ifTrue: [^ self menuBrowse].
! !

!SettingTreeNode methodsFor: 'menu' stamp: 'alain.plantec 3/24/2009 21:28'!
menu: menu shifted: b 
	menu
		add: 'Browse (b)' translated
		target: self
		selector: #browseDeclaration.
! !

!SettingTreeNode methodsFor: 'menu' stamp: 'alain.plantec 3/23/2009 10:11'!
menuBrowse
	self browseDeclaration! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 3/16/2009 22:14'!
package
	^ self item package! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 10:17'!
parentNode
	^ parentNode! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 08:53'!
parentNode: aNode
	parentNode := aNode
	! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 10:17'!
pathString
	^ String streamContents: [:s | 
		self parentNode
			ifNotNil: [:p | s nextPutAll: p pathString].
			s nextPut: $/.
			s nextPutAll: self item value name]
! !

!SettingTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 10:01'!
rowMorphListFor: aContainer
	^ item value ifNotNil: [:v | v rowMorphListFor: aContainer]! !

!SettingTreeNode methodsFor: 'updating' stamp: 'alain.plantec 3/25/2009 22:39'!
updateAccordingTo: aFilter 
	self contents do: [ :n | n updateAccordingTo: aFilter ].
	self contents removeAllSuchThat: [ :n | n isEmpty and: [ (aFilter keepHandler: n item) not ] ]! !

SettingTreeNode subclass: #SystemMenuTreeNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Menu-Browser'!

!SystemMenuTreeNode methodsFor: 'menu' stamp: 'alain.plantec 3/25/2009 23:20'!
keyStroke: aCharacter from: aTreeMorph 
	super keyStroke: aCharacter from: aTreeMorph. 
	aCharacter = $p ifTrue: [^ self popUp].
! !

!SystemMenuTreeNode methodsFor: 'menu' stamp: 'alain.plantec 3/25/2009 23:21'!
menu: menu shifted: b
	super menu: menu shifted: b.
	menu
		add: 'Popup (p)' translated
		target: self
		selector: #popUp.
! !

!SystemMenuTreeNode methodsFor: 'menu' stamp: 'alain.plantec 3/25/2009 23:17'!
menuItemIn: aMenu 
	| sub |
	self contents
		ifEmpty: [self item value menuItemIn: aMenu]
		ifNotEmpty: [sub := self item value subMenuItemIn: aMenu.
			self contents
				do: [:c | c item value menuItemIn: sub]]! !

!SystemMenuTreeNode methodsFor: 'menu' stamp: 'alain.plantec 3/25/2009 23:26'!
popUp
	| menu |
	menu := MenuMorph new.
	menu title: self item value name.
	menu addStayUpItem.
	self menuItemIn: menu.
	menu popUpEvent: nil in: World
! !

SettingTreeNode subclass: #SystemSettingTreeNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

!SystemSettingTreeNode methodsFor: 'menu' stamp: 'alain.plantec 3/24/2009 21:27'!
keyStroke: aCharacter from: aTreeMorph 
	super keyStroke: aCharacter from: aTreeMorph. 
	self item value haveDefault
		ifTrue: [aCharacter = $d
				ifTrue: [^ self menuSetToDefault]].
	self item value haveEditableList
		ifTrue: [aCharacter = $e
				ifTrue: [^ self menuEmptyList]] ! !

!SystemSettingTreeNode methodsFor: 'menu' stamp: 'alain.plantec 3/24/2009 21:28'!
menu: menu shifted: b 
	super menu: menu shifted: b.
	self item value haveDefault
		ifTrue: [menu
				add: 'Set to default (d)' translated
				target: self
				selector: #menuSetToDefault]. 
	self item value haveEditableList
		ifTrue: [menu
				add: 'Empty list (e)' translated
				target: self
				selector: #menuEmptyList]. 
	^ menu! !

!SystemSettingTreeNode methodsFor: 'menu' stamp: 'alain.plantec 3/24/2009 21:24'!
menuEmptyList
	| v |
	(v := self item value) haveEditableList ifTrue: [v emptyList]! !

!SystemSettingTreeNode methodsFor: 'menu' stamp: 'alain.plantec 3/24/2009 21:24'!
menuSetToDefault
	| v |
	(v := self item value) haveDefault
		ifTrue: [(self confirm: 'Set to default value ?' translated)
				ifTrue: [self item setToDefault]] ! !

SystemSettingTreeNode subclass: #SystemSettingUnclassifiedTreeNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

!SystemSettingUnclassifiedTreeNode classSide methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/24/2009 22:52'!
model: aModel 
	^ self
		with: (SystemSettingHandler pragma: (Pragma allNamed: #unclassifiedSettingRoot in: self class) first)
		model: aModel! !

!SystemSettingUnclassifiedTreeNode classSide methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/23/2009 12:31'!
unclassifiedSettingRoot
	<unclassifiedSettingRoot>
	^ (SettingManager newNode: '** Unclassified **')
		description: 'All setting values with unkown parent'! !

!SystemSettingUnclassifiedTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 12:10'!
childrenItems
	^ self model unclassified! !

!SystemSettingUnclassifiedTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 3/16/2009 16:45'!
icon
	^ MenuIcons smallDebugIcon! !

!SystemSettingUnclassifiedTreeNode methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 10:24'!
package
	^ nil! !

!String class methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 15:02'!
settingInputWidgetForNode: aSettingNode
	^ aSettingNode inputWidgetForString! !

Morph subclass: #MorphTreeNodeMorph
	instanceVariableNames: 'indentLevel isExpanded complexContents firstChild container nextSibling icon rowMorph controls'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Morphic'!

!MorphTreeNodeMorph methodsFor: 'drag and drop' stamp: 'alain.plantec 3/7/2009 09:29'!
acceptDroppingMorph: toDrop event: evt
	complexContents acceptDroppingObject: toDrop complexContents.
	toDrop delete.
	self highlightForDrop: false.! !

!MorphTreeNodeMorph methodsFor: 'private-container protocol' stamp: 'alain.plantec 3/10/2009 23:21'!
addChildrenForList: hostList addingTo: morphList withExpandedItems: expandedItems

	firstChild ifNotNil: [
		firstChild withSiblingsDo: [ :aNode | aNode delete].
	].
	firstChild := nil.
	complexContents hasContents ifFalse: [^self].
	firstChild := hostList 
		addMorphsTo: morphList
		from: complexContents contents 
		allowSorting: true
		withExpandedItems: expandedItems
		atLevel: indentLevel + 1.
	! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
balloonText

	^complexContents balloonText ifNil: [super balloonText]! !

!MorphTreeNodeMorph methodsFor: 'halos and balloon help' stamp: 'alain.plantec 3/7/2009 09:29'!
boundsForBalloon

	"some morphs have bounds that are way too big"
	container ifNil: [^super boundsForBalloon].
	^self boundsInWorld intersect: container boundsInWorld! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
canExpand

	^complexContents hasContents! !

!MorphTreeNodeMorph methodsFor: 'updating' stamp: 'alain.plantec 3/12/2009 09:48'!
changed
	"Need to invalidate the selection frame."
	container
		ifNil: [super changed] 
		ifNotNil: [self invalidRect: self selectionFrame]! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
children
	| children |
	children := OrderedCollection new.
	self childrenDo: [:each | children add: each].
	^children! !

!MorphTreeNodeMorph methodsFor: 'enumeration' stamp: 'alain.plantec 3/7/2009 09:29'!
childrenDo: aBlock

	firstChild ifNotNil: [
		firstChild withSiblingsDo: [ :aNode | aBlock value: aNode].
	]! !

!MorphTreeNodeMorph methodsFor: 'private-container protocol' stamp: 'alain.plantec 3/7/2009 09:29'!
complexContents

	^complexContents! !

!MorphTreeNodeMorph methodsFor: 'initialization' stamp: 'alain.plantec 3/17/2009 10:02'!
controlBounds
	| columns firstWidth controlBounds currControl currLeft currRight offset gap controlsCopy |
	controls ifEmpty: [^ #()].
	controlBounds := OrderedCollection new.
	offset := 0.
	controlsCopy := controls copy asOrderedCollection.
	container columns  isEmptyOrNil
		ifFalse: [ columns := container columns asOrderedCollection.
			gap := container leftGap.
			firstWidth := columns removeFirst.
			currControl := controlsCopy removeFirst.
			currLeft := currControl left. 
			currRight := currLeft + firstWidth - self spacerWidth -rowMorph cellInset.
			offset := offset + (currRight - currControl right ).
			controlBounds add: (currLeft @ currControl top corner: currRight @ currControl bottom).
			columns
				withIndexDo: [:width :idx | controlsCopy notEmpty
						ifTrue: [currLeft := currRight + container resizerWidth.
							currRight := currLeft + width - rowMorph cellInset.
							currControl := controlsCopy removeFirst.
							controlBounds add: (currLeft @ currControl top corner: currRight @ currControl bottom).
							offset := offset + (currRight - currControl right)]]].
	controlsCopy
		do: [:ctrl | 
			ctrl fullBounds.
			controlBounds add: (ctrl left + offset @ ctrl top corner: ctrl right + offset @ ctrl bottom)].
	^ controlBounds! !

!MorphTreeNodeMorph methodsFor: 'drawing' stamp: 'alain.plantec 3/7/2009 09:29'!
drawLineToggleToTextOn: aCanvas lineColor: lineColor hasToggle: hasToggle
	"If I am not the only item in my container, draw the line between:
		- my toggle (if any) or my left edge (if no toggle)
		- and my text left edge.
	Only draw now if no toggle."

	| myBounds myCenter hLineY hLineLeft myTheme|
	self isSoleItem ifTrue: [ ^self ].
	self hasToggle ifTrue: [^self].
	myBounds := self toggleBounds.
	myCenter := myBounds center.
	hLineY := myCenter y - 1.
	hLineLeft := myCenter x.
	"Draw line from toggle to text. Use optimised form since vertical."
	myTheme _ self theme.
	aCanvas
		frameRectangle: (hLineLeft @ hLineY corner: myBounds right + 3 @ (hLineY + 1))
		width: myTheme treeLineWidth
		colors: (myTheme treeLineColorsFrom: lineColor)
		dashes: myTheme treeLineDashes! !

!MorphTreeNodeMorph methodsFor: 'drawing' stamp: 'alain.plantec 3/9/2009 11:03'!
drawLinesOn: aCanvas lineColor: lineColor 
	| hasToggle |
	hasToggle := self hasToggle.
	"Draw line from toggle to text"
	self drawLineToggleToTextOn: aCanvas lineColor: lineColor hasToggle: hasToggle.

	"Draw the line from my toggle to the nextSibling's toggle"
	self nextSibling ifNotNil: [ self drawLinesToNextSiblingOn: aCanvas lineColor: lineColor hasToggle: hasToggle ].

	"If I have children and am expanded, draw a line to my first child"
	(self firstChild notNil and: [ self isExpanded ])
		ifTrue: [ self drawLinesToFirstChildOn: aCanvas lineColor: lineColor]! !

!MorphTreeNodeMorph methodsFor: 'drawing' stamp: 'alain.plantec 3/7/2009 09:29'!
drawLinesToFirstChildOn: aCanvas lineColor: lineColor 
	"Draw line from me to first child.
	Don't bother if the first child has a toggle.."

	| vLineX vLineTop vLineBottom childBounds childCenter myTheme|
	self firstChild hasToggle ifTrue: [^self].
	childBounds := self firstChild toggleBounds.
	childCenter := childBounds center.
	vLineX := childCenter x.
	vLineTop := bounds bottom.
	self firstChild hasToggle
		ifTrue: [vLineBottom := childCenter y - (childBounds height // 2) + 1]
		ifFalse: [vLineBottom := childCenter y - 2].
	myTheme _ self theme.
	aCanvas
		frameRectangle: (vLineX @ vLineTop corner: vLineX + 1 @ vLineBottom)
		width: myTheme treeLineWidth
		colors: (myTheme treeLineColorsFrom: lineColor)
		dashes: myTheme treeLineDashes! !

!MorphTreeNodeMorph methodsFor: 'drawing' stamp: 'alain.plantec 3/9/2009 10:08'!
drawLinesToNextSiblingOn: aCanvas lineColor: lineColor hasToggle: hasToggle
	"Draw line from me to next sibling"
	
	| myBounds nextSibBounds vLineX myCenter vLineTop vLineBottom myTheme|
	myBounds := self toggleBounds.
	nextSibBounds := self nextSibling toggleBounds.
	myCenter := myBounds center.
	vLineX := myCenter x.
	vLineTop := myCenter y + 1.
	vLineBottom := nextSibBounds center y - 1.
	"Draw line from me to next sibling"
	myTheme _ self theme.
	aCanvas
		frameRectangle: (vLineX @ vLineTop corner: vLineX + 1 @ vLineBottom)
		width: myTheme treeLineWidth
		colors: (myTheme treeLineColorsFrom: lineColor)
		dashes: myTheme treeLineDashes! !

!MorphTreeNodeMorph methodsFor: 'drawing' stamp: 'alain.plantec 3/8/2009 13:49'!
drawMouseDownHighlightOn: aCanvas
	"Draw with a dotted border."
	
	|frame|
	self highlightedForMouseDown ifTrue: [
		container ifNil: [^super drawMouseDownHighlightOn: aCanvas].
		frame := self selectionFrame.
		aCanvas 
			frameRectangle: frame
			width: 1
			colors: {container mouseDownHighlightColor. Color transparent}
			 dashes: #(1 1)]! !

!MorphTreeNodeMorph methodsFor: 'drawing' stamp: 'alain.plantec 3/11/2009 08:03'!
drawOn: aCanvas 
	| tRect sRect | 
	aCanvas 
			frameRectangle: self selectionFrame
			width: 1
			colors: {Color veryLightGray. Color transparent}
			 dashes: #(1 2).
	tRect := self toggleRectangle.
	self drawToggleOn: aCanvas in: tRect.
	sRect := bounds withLeft: tRect right + container gapBetweenToggleAndIcon.
	icon notNil ifTrue: [aCanvas translucentImage: icon at: sRect left @ (self top + (self height - icon height // 2))].
! !

!MorphTreeNodeMorph methodsFor: 'drawing' stamp: 'alain.plantec 3/7/2009 09:29'!
drawToggleOn: aCanvas in: aRectangle

	| aForm centeringOffset |
	complexContents hasContents ifFalse: [^self].
	aForm := isExpanded 
		ifTrue: [container expandedForm]
		ifFalse: [container notExpandedForm].
	centeringOffset := ((aRectangle height - aForm extent y) / 2.0) truncated.
	^aCanvas 
		translucentImage: aForm 
		at: (aRectangle topLeft translateBy: 0 @ centeringOffset).
! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
firstChild

	^firstChild! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
hasIcon
	"Answer whether the receiver has an icon."
	^ icon notNil! !

!MorphTreeNodeMorph methodsFor: 'private' stamp: 'alain.plantec 3/7/2009 09:29'!
hasToggle
	^ complexContents hasContents! !

!MorphTreeNodeMorph methodsFor: 'private-container protocol' stamp: 'alain.plantec 3/7/2009 09:29'!
highlight

	complexContents highlightingColor ifNotNil: [self color: complexContents highlightingColor].
	self changed.
	
! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
icon
	"answer the receiver's icon"
	^ icon! !

!MorphTreeNodeMorph methodsFor: 'mouse events' stamp: 'alain.plantec 3/7/2009 09:29'!
inToggleArea: aPoint

	^self toggleRectangle containsPoint: aPoint! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/10/2009 13:16'!
indentGap
	^ container indentGap * indentLevel! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
indentLevel

	^indentLevel! !

!MorphTreeNodeMorph methodsFor: 'initialization' stamp: 'alain.plantec 3/16/2009 13:40'!
initWithContents: anObject prior: priorMorph forList: hostList indentLevel: newLevel 
	| spacer rowControls |
	self initialize.
	container := hostList.
	complexContents := anObject.
	isExpanded := false.
	nextSibling := firstChild := nil.
	priorMorph ifNotNil: [priorMorph nextSibling: self].
	indentLevel := newLevel.
	icon := anObject icon.
	self addMorphBack: (spacer := (self transparentSpacerOfSize: (1 @ 1))).
	spacer width: self spacerWidth.
	controls := ((complexContents rowMorphListFor: container) ifNil: [#()]) asOrderedCollection.
	rowControls := OrderedCollection new.
	controls do: [:ctrl | rowControls add: ctrl] separatedBy: [rowControls add: ((self transparentSpacerOfSize: container resizerWidth @1) )].
	rowMorph := UITheme current newRowIn: World for: rowControls.
	rowMorph fullBounds.
	rowMorph cellInset: 2.
	self addMorphBack: rowMorph.
	self updateColumns.
	! !

!MorphTreeNodeMorph methodsFor: 'initialization' stamp: 'alain.plantec 3/10/2009 21:54'!
initialize
	"initialize the state of the receiver"
	super initialize.
	self layoutPolicy: TableLayout new.
	self hResizing: #shrinkWrap.
	self vResizing: #shrinkWrap.
	self listDirection: #leftToRight.
	self cellPositioning: #topLeft.
	self color: Color transparent.
! !

!MorphTreeNodeMorph methodsFor: 'updating' stamp: 'alain.plantec 3/12/2009 11:43'!
innerWidgetChanged
	container ifNotNil: [container innerWidgetChanged]! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
isExpanded

	^isExpanded! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
isExpanded: aBoolean

	isExpanded := aBoolean! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
isFirstItem
	^owner submorphs first == self! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
isSoleItem
	^self isFirstItem and: [ owner submorphs size = 1 ]! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
lastChild
	"Answer the last child."

	|c|
	c _ self firstChild ifNil: [^nil].
	[c nextSibling isNil] whileFalse: [c _ c nextSibling].
	^c! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/9/2009 08:22'!
minHeight
	"Answer the minimum height of the receiver."
	
	| iconHeight |
	iconHeight := self hasIcon
				ifTrue: [self icon height + 2]
				ifFalse: [0].
	^(rowMorph height max: iconHeight) max: super minHeight! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/9/2009 08:22'!
minWidth
	"Fixed to work such that guessed width is unnecessary in
	#adjustSubmorphPositions."

	| iconWidth |
	iconWidth := self hasIcon
				ifTrue: [self icon width + 2]
				ifFalse: [0].
	^(13 * indentLevel + 15 + rowMorph minWidth + iconWidth) max: super minWidth! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
nextSibling

	^nextSibling! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
nextSibling: anotherMorph

	nextSibling := anotherMorph! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
openItemPath: anArray
	"Open a path based on wrapper item equivalence. Generally more specific
	than #openPath: (string based)."
	
	| found |
	anArray isEmpty
		ifTrue: [^ container setSelectedMorph: nil].
	found := nil.
	self
		withSiblingsDo: [:each | found
				ifNil: [(each complexContents withoutListWrapper == anArray first
							or: [anArray first isNil])
						ifTrue: [found := each]]].
	found
		ifNotNil: [found isExpanded
				ifFalse: [found toggleExpandedState.
					container adjustSubmorphPositions].
			found changed.
			anArray size = 1
				ifTrue: [^ container setSelectedMorph: found].
			^ found firstChild
				ifNil: [container setSelectedMorph: nil]
				ifNotNil: [found firstChild openItemPath: anArray allButFirst]].
	^container setSelectedMorph: nil! !

!MorphTreeNodeMorph methodsFor: 'private-container protocol' stamp: 'alain.plantec 3/7/2009 09:29'!
openPath: anArray 
	| found |
	anArray isEmpty
		ifTrue: [^ container setSelectedMorph: nil].
	found := nil.
	self
		withSiblingsDo: [:each | found
				ifNil: [(each complexContents asString = anArray first
							or: [anArray first isNil])
						ifTrue: [found := each]]].
	found
		ifNil: ["try again with no case sensitivity"
			self
				withSiblingsDo: [:each | found
						ifNil: [(each complexContents asString sameAs: anArray first)
								ifTrue: [found := each]]]].
	found
		ifNotNil: [found isExpanded
				ifFalse: [found toggleExpandedState.
					container adjustSubmorphPositions].
			found changed.
			anArray size = 1
				ifTrue: [^ container setSelectedMorph: found].
			^ found firstChild
				ifNil: [container setSelectedMorph: nil]
				ifNotNil: [found firstChild openPath: anArray allButFirst]].
	^ container setSelectedMorph: nil! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
outerBounds
	"Return the 'outer' bounds of the receiver, e.g., the bounds that need to be invalidated when the receiver changes."
	
	|box|
	box _ super outerBounds.
	container ifNil: [^box].
	^box left: (box left min: self selectionFrame left)! !

!MorphTreeNodeMorph methodsFor: 'private-container protocol' stamp: 'alain.plantec 3/7/2009 09:29'!
recursiveAddTo: aCollection

	firstChild ifNotNil: [
		firstChild withSiblingsDo: [ :aNode | aNode recursiveAddTo: aCollection].
	].
	aCollection add: self
	! !

!MorphTreeNodeMorph methodsFor: 'private-container protocol' stamp: 'alain.plantec 3/7/2009 09:29'!
recursiveDelete

	firstChild ifNotNil: [
		firstChild withSiblingsDo: [ :aNode | aNode recursiveDelete].
	].
	self delete
	! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
selectionFrame
	"Answer the selection frame rectangle."

	|frame|
	frame := self bounds: self bounds in: container.
	frame := self
		bounds: ((frame left: container innerBounds left) right: container innerBounds right)
		from: container.
	^frame! !

!MorphTreeNodeMorph methodsFor: 'initialization' stamp: 'alain.plantec 3/10/2009 22:37'!
spacerWidth
	| sRect  spacer |
	spacer := self firstSubmorph.
	sRect := bounds withLeft: self toggleRectangle right + container gapBetweenToggleAndIcon.
	sRect := sRect withLeft: sRect left + container iconReservedExtent x + container gapAfterIcon.
	^ sRect left - bounds left.
! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
theme
	"Answer the ui theme that provides controls.
	Done directly here to avoid performance hit of
	looking up in window."

	^UITheme current! !

!MorphTreeNodeMorph methodsFor: 'private' stamp: 'alain.plantec 3/7/2009 09:29'!
toggleBounds
	^self toggleRectangle! !

!MorphTreeNodeMorph methodsFor: 'private-container protocol' stamp: 'alain.plantec 3/7/2009 09:29'!
toggleExpandedState

 	| newChildren toDelete c |

	isExpanded := isExpanded not.
	toDelete := OrderedCollection new.
	firstChild ifNotNil: [
		firstChild withSiblingsDo: [ :aNode | aNode recursiveAddTo: toDelete].
	].
	container noteRemovalOfAll: toDelete.
	(isExpanded and: [complexContents hasContents]) ifFalse: [
		^self changed
	].
	(c := complexContents contents) isEmpty ifTrue: [^self changed].
	newChildren := container 
		addSubmorphsAfter: self 
		fromCollection: c 
		allowSorting: true.
	firstChild := newChildren first.
! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 17:54'!
toggleImageMorph
	^ ImageMorph new
		image: (isExpanded
				ifTrue: [container expandedForm]
				ifFalse: [container notExpandedForm]) ! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/10/2009 13:17'!
toggleRectangle
	^(bounds left + self indentGap) @ bounds top extent: container toggleImageWidth @ bounds height! !

!MorphTreeNodeMorph methodsFor: 'drawing' stamp: 'alain.plantec 3/7/2009 09:29'!
unhighlight

	complexContents highlightingColor ifNotNil: [self color: Color black].
	self changed.
	
	
! !

!MorphTreeNodeMorph methodsFor: 'initialization' stamp: 'alain.plantec 3/10/2009 21:16'!
updateColumns
	|  columns spacer |
	container columns  isEmptyOrNil ifTrue: [^ self].
	columns := container columns asOrderedCollection.
	spacer := self firstSubmorph.
	spacer width: self spacerWidth.
	self controlBounds withIndexDo: [:bnd :idx | | ctrl |
		ctrl := controls at: idx.
		ctrl width: bnd width].
	rowMorph fullBounds! !

!MorphTreeNodeMorph methodsFor: 'accessing' stamp: 'alain.plantec 3/7/2009 09:29'!
userString
	"Add leading tabs to my userString"
	^ (String new: indentLevel withAll: Character tab), super userString
! !

!MorphTreeNodeMorph methodsFor: 'private' stamp: 'alain.plantec 3/7/2009 09:29'!
withSiblingsDo: aBlock

	| node |
	node := self.
	[node isNil] whileFalse: [
		aBlock value: node.
		node := node nextSibling
	].! !

!MorphTreeNodeMorph methodsFor: 'converting' stamp: 'alain.plantec 3/7/2009 09:29'!
withoutListWrapper

	^complexContents withoutListWrapper! !

AbstractResizerMorph subclass: #MorphTreeResizerMorph
	instanceVariableNames: 'traceMorph oldColor lineNumber treeList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Morphic'!

!MorphTreeResizerMorph class methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/12/2009 21:40'!
fastSplitterResize
	^ Preferences fastDragWindowForMorphic! !

!MorphTreeResizerMorph class methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/9/2009 13:18'!
treeList: aTreeList lineNumber: anInteger
	^ self new treeList: aTreeList lineNumber: anInteger! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/9/2009 12:56'!
adoptPaneColor: paneColor 
	"Change our color too."
	super adoptPaneColor: paneColor.
	self fillStyle: self normalFillStyle! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/10/2009 23:00'!
getOldColor
	^ oldColor ifNil: [Color transparent]! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/9/2009 13:08'!
mouseDown: anEvent 
	"A mouse button has been pressed.
	Update the color for feedback and store the mouse
	position and relative offset to the receiver."
	| cp |
	(self bounds containsPoint: anEvent cursorPoint)
		ifTrue: [oldColor := self color.
			self setGrabbedColor].
	cp := anEvent cursorPoint.
	lastMouse := {cp. cp - self position}! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/11/2009 07:31'!
mouseMove: anEvent 
	anEvent hand temporaryCursor
		ifNil: [^ self].
	self class fastSplitterResize
		ifTrue: [traceMorph
				ifNil: [traceMorph := Morph newBounds: self bounds.
					traceMorph borderColor: Color lightGray.
					traceMorph borderWidth: 1.
					self owner addMorph: traceMorph].
			traceMorph position: (anEvent cursorPoint x - lastMouse second x) @ traceMorph position y]
		ifFalse: [self updateFromEvent: anEvent]! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/9/2009 13:04'!
mouseUp: anEvent
	"Change the cursor back to normal if necessary and change the color back to normal."
	
	(self bounds containsPoint: anEvent cursorPoint)
		ifFalse: [anEvent hand showTemporaryCursor: nil].
	self class fastSplitterResize
		ifTrue: [self updateFromEvent: anEvent].
	traceMorph ifNotNil: [traceMorph delete. traceMorph := nil].
	self adoptPaneColor: self paneColor.
	self triggerEvent: #mouseUp! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/9/2009 12:55'!
normalFillStyle
	"Return the normal fillStyle of the receiver."
	^ self theme splitterNormalFillStyleFor: self! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/10/2009 14:09'!
normalizedX: x

	^ x! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/10/2009 14:09'!
normalizedY: y 
	^y! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/9/2009 12:55'!
pressedFillStyle
	"Return the pressed fillStyle of the receiver."
	^ self theme splitterPressedFillStyleFor: self! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/9/2009 12:53'!
resizeCursor
	^ Cursor resizeForEdge: #left! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/9/2009 13:09'!
setGrabbedColor
	"Set the color of the receiver when it is grabbed."
	
	self fillStyle: self pressedFillStyle! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/9/2009 12:55'!
shouldDraw
	^ true! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/11/2009 07:45'!
splitsTopAndBottom
	^ false! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/9/2009 13:19'!
treeList: aTreeList lineNumber: anInteger
	treeList := aTreeList.
	lineNumber := anInteger! !

!MorphTreeResizerMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/11/2009 08:14'!
updateFromEvent: anEvent 
	"Update the splitter and attached morph positions from
	the mouse event.
	Take into account the mouse down offset."
	| pNew previousX newWidth minX newLeft |
	pNew := anEvent cursorPoint - lastMouse second.
	minX := lineNumber = 1 
		ifTrue: [treeList minResizerX] 
		ifFalse: [(treeList columnResizers at: lineNumber - 1) right].
	newLeft := (minX max: pNew x).
	self left: newLeft.
	previousX := lineNumber = 1 
		ifTrue: [treeList scroller left] 
		ifFalse: [(treeList columnResizers at: lineNumber - 1) left].
	newWidth := treeList leftGap max: (self left - previousX) .
	treeList columns at: lineNumber put: newWidth.
	treeList updateColumns.

! !

Announcement subclass: #PragmaCollectorAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Pragma'!

PragmaCollectorAnnouncement subclass: #PragmaCollectorReinitialized
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Pragma'!

PragmaCollectorAnnouncement subclass: #PragmaHandlerAnnouncement
	instanceVariableNames: 'handler'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Pragma'!

!PragmaHandlerAnnouncement methodsFor: 'accessing' stamp: 'alain.plantec 3/21/2009 14:29'!
handler
	^ handler! !

!PragmaHandlerAnnouncement methodsFor: 'accessing' stamp: 'alain.plantec 3/21/2009 14:30'!
handler: aPragmaHandler
	handler := aPragmaHandler! !

!PragmaHandlerAnnouncement methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 09:08'!
message
	^ ''! !

PragmaHandlerAnnouncement subclass: #PragmaRegistered
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Pragma'!

PragmaHandlerAnnouncement subclass: #PragmaUnregistered
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Pragma'!

PragmaHandlerAnnouncement subclass: #PragmaUpdated
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Pragma'!

DialogWindow subclass: #SettingPackageChooser
	instanceVariableNames: 'list listIndex listSelections listMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 22:06'!
chooseFrom: aList 
	list := aList.
	listSelections := nil.
	self updateList! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 22:14'!
chosen
	| chosen |
	chosen := OrderedCollection new.
	1
		to: self list size
		do: [:i | (self listSelections at: i)
				ifTrue: [chosen
						add: (self list at: i)]].
	^ chosen! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 22:18'!
chosen: aList 
	listSelections := nil.
	aList
		do: [:i | (self list
						indexOf: i
						ifAbsent: [])
				ifNotNil: [:idx | self listSelections at: idx put: true]].
	self updateList.! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/18/2009 07:11'!
deselectAll
	listSelections := nil.
	self updateList
	
	! !

!SettingPackageChooser methodsFor: 'open/close' stamp: 'alain.plantec 3/17/2009 22:12'!
initialExtent
	"Answer the initial extent for the receiver.
	Adjust the text if the text	would be wider than 1/4
	the display width."
	^ (super initialExtent x max: 250)
		@ 500! !

!SettingPackageChooser methodsFor: 'initialization' stamp: 'alain.plantec 3/17/2009 17:43'!
initialize
	super initialize.
	self title: 'Choose'.
! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 22:01'!
list
	^ list
		ifNil: [list := SortedCollection new]! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 22:01'!
listIndex
	^ listIndex ifNil: [listIndex := 0]					
! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 22:02'!
listIndex: anInteger
	listIndex := anInteger.
	self changed: #listIndex
! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 22:33'!
listMorph
	^ listMorph
		ifNil: [listMorph := PluggableListMorphOfMany
						on: self
						list: #list
						primarySelection: #listIndex
						changePrimarySelection: #toggleListIndex:
						listSelection: #listSelectionAt:
						changeListSelection: #listSelectionAt:put:
						menu: nil]! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 22:07'!
listSelectionAt: index
	^ self listSelections at: index! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 22:33'!
listSelectionAt: index put: value
	^ listSelections at: index put: value! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 22:04'!
listSelections
	listSelections ifNil: [
		list ifNotNil: [
			listSelections := Array new: list size withAll: false]].
	^ listSelections! !

!SettingPackageChooser methodsFor: 'open/close' stamp: 'alain.plantec 3/18/2009 07:09'!
newButtons
	^ {self
		newButtonFor: self
		getState: nil
		action: #deselectAll
		arguments: nil
		getEnabled: nil
		label: 'Deselect all' translated
		help: 'Deselect all packages' translated}, super newButtons! !

!SettingPackageChooser methodsFor: 'open/close' stamp: 'alain.plantec 3/17/2009 22:11'!
newContentMorph
	| col |
	col := (self newRow: {self listMorph vResizing: #spaceFill; hResizing: #spaceFill})
				vResizing: #spaceFill.
	^ col vResizing: #spaceFill! !

!SettingPackageChooser methodsFor: 'accessing' stamp: 'alain.plantec 3/17/2009 22:08'!
toggleListIndex: newListIndex

	listIndex ~= 0 ifTrue: [listSelections at: listIndex put: false].
	newListIndex ~= 0 ifTrue: [listSelections at: newListIndex put: true].
	listIndex := newListIndex.
	self changed: #listIndex.
	self contentsChanged! !

!SettingPackageChooser methodsFor: 'updating' stamp: 'alain.plantec 3/17/2009 22:06'!
updateList
	self changed: #list.
! !

!Color class methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 14:48'!
settingInputWidgetForNode: aSettingNode
	^ aSettingNode inputWidgetForColor! !

!Association methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/24/2009 23:20'!
settingFixedDomainValueNodeFrom: aSettingNode 
	^ aSettingNode fixedDomainValueNodeForAssociation: self! !

!LogicalFont methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/19/2009 10:02'!
settingStoreOn: aStream 
	aStream nextPut: $(.
	aStream nextPutAll: self class name.
	aStream nextPut: Character space.
	aStream nextPutAll: 'familyName: '.
	self familyName settingStoreOn: aStream.
	aStream nextPut: Character space.
	aStream nextPutAll: 'fallbackFamilyNames: '.
	self fallbackFamilyNames settingStoreOn: aStream.
	aStream nextPut: Character space.
	aStream nextPutAll: 'pointSize: '.
	self pointSize settingStoreOn: aStream.
	aStream nextPut: Character space.
	aStream nextPutAll: 'stretchValue: '.
	self stretchValue settingStoreOn: aStream.
	aStream nextPut: Character space.
	aStream nextPutAll: 'weightValue: '.
	self weightValue settingStoreOn: aStream.
	aStream nextPut: Character space.
	aStream nextPutAll: 'slantValue: '.
	self slantValue settingStoreOn: aStream.
	aStream nextPut: $)! !

!AbstractFont class methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 14:49'!
settingInputWidgetForNode: aSettingNode
	^ aSettingNode inputWidgetForFont! !

DropListMorph subclass: #EditableDropListMorph
	instanceVariableNames: 'addToListSel content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Morphic'!

!EditableDropListMorph class methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/13/2009 16:13'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel useIndex: useIndex addToList: addToListSel 
	^ self
		on: anObject
		list: getListSel
		selected: getSelectionSel
		changeSelected: setSelectionSel
		useIndex: useIndex
		addToList: addToListSel 
		class: nil
		getEnabled: nil! !

!EditableDropListMorph class methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/13/2009 16:12'!
on: anObject list: getListSel selected: getSelectionSel changeSelected: setSelectionSel useIndex: useIndex addToList: addToListSel class: aClass getEnabled: getEnabledSel 
	^ (super
		on: anObject
		list: getListSel
		selected: getSelectionSel
		changeSelected: setSelectionSel
		useIndex: useIndex) convertTo: aClass; 
		 getEnabledSelector: getEnabledSel;
		 addToList: addToListSel;
		 yourself! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/13/2009 13:03'!
addToList: aSelector
	addToListSel := aSelector! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/13/2009 15:26'!
content
	^ content
! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/13/2009 15:51'!
content: aString
	content := aString.
	self model perform: addToListSel with: aString.
	self listSelectionIndex: (self list indexOf: aString).
	self updateList.
	! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/13/2009 16:30'!
convertTo: aClass 
	self contentMorph convertTo: aClass ! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/16/2009 10:36'!
initialize
	super initialize.
	self height: self contentMorph minHeight! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/13/2009 18:21'!
listHeight
	"Answer the height for the list."
	^(self listMorph listMorph height + 12) min: 200! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/16/2009 10:37'!
newContentMorph
	"Answer a new content morph"
	^ (UITheme current
		newTextEntryIn: World
		for: self
		get: #content
		set: #content:
		class: String
		getEnabled: nil
		help: nil) 
		 hResizing: #spaceFill;
		 autoAccept: false! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/13/2009 15:44'!
updateContentColor: paneColor
	"Change the content text color."
	
	self enabled
		ifTrue: [self contentMorph setTextColor: Color black]
		ifFalse: [self contentMorph setTextColor: paneColor duller]! !

!EditableDropListMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/13/2009 15:36'!
updateContents
	"Update the contents."

	|sel|
	self contentMorph
		setText: (self listSelectionIndex > 0
			ifTrue: [sel := self list at: self listSelectionIndex.
					sel isText
						ifTrue: [sel]
						ifFalse: [sel asString]]
			ifFalse: [' ']) "needs something to keep font"! !

!Number class methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 15:09'!
settingInputWidgetForNode: aSettingNode
	^ aSettingNode inputWidgetForNumber! !

!Boolean class methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 14:48'!
settingInputWidgetForNode: aSettingNode
	^ aSettingNode inputWidgetForBoolean! !

SimpleHierarchicalListMorph subclass: #MorphTreeMorph
	instanceVariableNames: 'enabled columnResizers lightFrame'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Morphic'!

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/19/2009 16:51'!
addColumnResizers
	| offset |
	offset := 0.
	columnResizers := self columnResizerFrames
				withIndexCollect: [:frm :idx | (MorphTreeResizerMorph treeList: self lineNumber: idx) bounds: frm].
	self addAllMorphs: columnResizers.
	columnResizers
		do: [:cl | cl comeToFront]! !

!MorphTreeMorph methodsFor: 'private' stamp: 'alain.plantec 3/11/2009 08:24'!
addSubmorphsAfter: parentMorph fromCollection: aCollection allowSorting: sortBoolean
	"Update the extent on each morph."
	
	|answer|
	answer := super addSubmorphsAfter: parentMorph fromCollection: aCollection allowSorting: sortBoolean.
	self scroller submorphsDo: [:i |
		i
			extent: i minWidth @ i minHeight].
	self updateColumnResizers.
	^answer! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/11/2009 08:21'!
columnResizerFrames
	| offset |
	offset := 0.
	^ columns
		ifNil: [#()]
		ifNotNil: [columns
				collect: [:col | 
					offset = 0 
						ifTrue: [offset := offset + (self minResizerOffset max: col)]
						ifFalse: [offset := offset + col].
					scroller left + offset @ self top corner: scroller left + offset + self resizerWidth @ self bottom]]! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/10/2009 12:35'!
columnResizers
	^ columnResizers ! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/11/2009 07:23'!
columns: aCollection 
	super columns: aCollection asOrderedCollection.
	columns := columns collect: [:c | c + self leftGap].
	self addColumnResizers! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/10/2009 23:21'!
extent: aPoint
	super extent: aPoint.
	self updateColumns.
! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/10/2009 13:32'!
gapAfterIcon
	^ 5! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/10/2009 13:24'!
gapBetweenToggleAndIcon
	^ 4! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/10/2009 13:20'!
iconReservedExtent
	^ 16 @ 16! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/10/2009 13:15'!
indentGap
	^ 13! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/19/2009 16:52'!
indentingItemClass
	
	^MorphTreeNodeMorph! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/12/2009 11:42'!
innerWidgetChanged
	self setScrollDeltas.
	self adjustSubmorphPositions! !

!MorphTreeMorph methodsFor: 'private' stamp: 'alain.plantec 3/9/2009 13:41'!
insertNewMorphs: morphList 
	"Update the extent on each morph."
	morphList
		do: [:m | m extent: m minWidth @ m minHeight].
	^ super insertNewMorphs: morphList! !

!MorphTreeMorph methodsFor: 'private' stamp: 'alain.plantec 3/9/2009 10:33'!
layoutBounds: aRectangle
	"Set the bounds for laying out children of the receiver.
	Update the scroller and scrollbars now since bounds set directly
	(not via #extent:)."
	
	super layoutBounds: aRectangle.
	self
		resizeScroller;
		setScrollDeltas! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/11/2009 11:06'!
leftGap
	^self toggleImageWidth + self gapBetweenToggleAndIcon + self iconReservedExtent x + self gapAfterIcon.
! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/11/2009 08:19'!
minResizerOffset
	| minX |
	minX := self leftGap.
	scroller submorphsDo: [:sm | minX := minX max: (sm spacerWidth)].
	^ minX! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/11/2009 08:34'!
minResizerX
	^ scroller left + self minResizerOffset! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/10/2009 22:24'!
resizerWidth
	^ 5! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/10/2009 13:13'!
toggleImageHeight
	| expandedImage notExpandedImage |
	expandedImage := ImageMorph new image: self expandedForm.
	notExpandedImage := ImageMorph new image: self notExpandedForm.
	^ expandedImage height max: notExpandedImage height.! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/10/2009 13:14'!
toggleImageWidth
	| expandedImage notExpandedImage |
	expandedImage := ImageMorph new image: self expandedForm.
	notExpandedImage := ImageMorph new image: self notExpandedForm.
	^ expandedImage width max: notExpandedImage width.! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/16/2009 16:15'!
update: aSymbol 
	super update: aSymbol.
! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/11/2009 08:26'!
updateColumnResizers
	columnResizers
		ifNotNil: [self columnResizerFrames
				doWithIndex: [:frm :idx | (columnResizers at: idx)
						bounds: frm]].
	scroller changed! !

!MorphTreeMorph methodsFor: 'as yet unclassified' stamp: 'alain.plantec 3/10/2009 12:22'!
updateColumns
	self scroller
		submorphsDo: [:i | i updateColumns].
	self updateColumnResizers
! !

AbstractHierarchicalList subclass: #SettingTree
	instanceVariableNames: 'roots collector status keywords viewedPackages searchedText treeBuilder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

!SettingTree class methodsFor: 'opening' stamp: 'alain.plantec 3/23/2009 18:38'!
forKeywords: aCollectionOfRegExps
	^ self new keywords: aCollectionOfRegExps! !

!SettingTree methodsFor: 'updating' stamp: 'alain.plantec 3/23/2009 18:38'!
applyFilters
	| filter |
	self viewedPackages
		ifNotEmpty: [filter := SettingPackageFilter new
						packages: self viewedPackages.
			self updateAccordingTo: filter].
	self searchedText
		ifNotEmpty: [filter := SettingSearchTokenFilter new token: self searchedText.
			self updateAccordingTo: filter].
	self updateList! !

!SettingTree methodsFor: 'UI' stamp: 'alain.plantec 3/24/2009 09:10'!
buildWindowIn: aWindow
	^ self buildWindowIn: aWindow verticalGap: 0 
! !

!SettingTree methodsFor: 'UI' stamp: 'alain.plantec 3/24/2009 17:00'!
buildWindowIn: aWindow verticalGap: startGap 
	| statusView toolBar treeMorph toolBarY gap localGap packageListView |
	treeMorph := self treeMorphIn: aWindow.
	statusView := self statusViewIn: aWindow.
	packageListView := self packageListViewIn: aWindow.
	toolBar := self toolBarIn: aWindow.
	localGap := 5.
	gap := startGap + localGap.
	toolBarY := toolBar minExtent y + gap.
	aWindow 
		addMorph: toolBar
		fullFrame: (LayoutFrame 
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ (gap ) corner: 0 @ (toolBarY + localGap))).
	aWindow 
		addMorph: treeMorph
		fullFrame: (LayoutFrame 
				fractions: (0 @ 0 corner: 1 @ 0.99)
				offsets: (0 @ (toolBarY + localGap + localGap) corner: 0 @ 100 negated)).
	aWindow 
		addMorph: statusView
		fullFrame: (LayoutFrame 
				fractions: (0 @ 0.99 corner: 0.55 @ 1)
				offsets: (0 @ 100 negated corner: 0 @ 0)).
	aWindow 
		addMorph: packageListView
		fullFrame: (LayoutFrame 
				fractions: (0.55 @ 0.99 corner: 1 @ 1)
				offsets: (0 @ 100 negated corner: 0 @ 0))! !

!SettingTree methodsFor: 'updating' stamp: 'alain.plantec 3/23/2009 18:38'!
changePackageSet: aSet 
	| |
	aSet ~= self viewedPackages
		ifTrue: [roots := nil.
			self viewedPackages: aSet.
			self applyFilters ].
	^ true! !

!SettingTree methodsFor: 'updating' stamp: 'alain.plantec 3/23/2009 18:38'!
changeSearchedText: aString 
	| |
	self searchedText ~= aString ifTrue: [
	self searchedText: aString.
	roots := nil.
	self applyFilters].
	^ true! !

!SettingTree methodsFor: 'UI' stamp: 'alain.plantec 3/24/2009 16:58'!
choosePackagesIn: aWindow
	| chooser allPackages chosen |
	allPackages := PackageOrganizer default packageNames asSortedCollection.
	chosen := self viewedPackages collect: [:p | p packageName].
	aWindow openModal: (chooser := SettingPackageChooser new chooseFrom: allPackages; chosen: chosen; yourself).
	chooser cancelled
		ifFalse: [self changePackageSet: (chooser chosen collect: [:c | PackageOrganizer default packageNamed: c ifAbsent: []])] ! !

!SettingTree methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 18:38'!
collector
	^ collector
		ifNil: [collector := self defaultCollector.
			self prepareCollector.
			collector reset]! !

!SettingTree methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 18:38'!
collector: aSettingCollector 
	collector := aSettingCollector.
	self prepareCollector.
	self forceRebuild! !

!SettingTree methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 18:38'!
defaultCollector
	^ PragmaCollector requestor: self! !

!SettingTree methodsFor: 'updating' stamp: 'alain.plantec 3/23/2009 18:38'!
expandAll
	self changed: #(#roots #expandAll).
! !

!SettingTree methodsFor: 'updating' stamp: 'alain.plantec 3/26/2009 14:51'!
forceRebuild
		roots := nil.
		self noteNewSelection: nil.
		self updateList! !

!SettingTree methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 18:38'!
getDescription
	^ self getCurrentSelection
		ifNil: [status contents]
		ifNotNil: [:selection | Text
				streamContents: [:s |
					selection package ifNotNil: [:pkg |
						s nextPutAll: (Text string: 'Package: ', pkg packageName attribute: TextEmphasis bold).
						s nextPut: Character cr].
					s nextPutAll: selection description]]! !

!SettingTree methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 18:38'!
getViewedPackageNames
	^ Text
		streamContents: [:s | self viewedPackages
				ifEmpty: [s nextPutAll: 'All packages']
				ifNotEmpty: [:selections | 
					(selections asSet = MCWorkingCopy allManagers asSet)
						ifTrue: [s nextPutAll: 'All packages']
						ifFalse: [selections
								do: [:package | 
									s nextPutAll: package packageName.
									s nextPut: Character cr]]]]! !

!SettingTree methodsFor: 'initializing' stamp: 'alain.plantec 3/23/2009 18:38'!
initialize
	super initialize.
	status := '' writeStream.
! !

!SettingTree methodsFor: 'testing' stamp: 'alain.plantec 3/23/2009 18:38'!
keepPragma: aPragma
	^ self keywords anySatisfy: [:rxString | aPragma keyword asString matchesRegex: rxString]! !

!SettingTree methodsFor: 'menu' stamp: 'alain.plantec 3/23/2009 18:38'!
keyStroke: aCharacter from: aTreeMorph 
	self getCurrentSelection
		ifNotNil: [:current | current keyStroke: aCharacter from: aTreeMorph]! !

!SettingTree methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 22:54'!
keywords
	^ keywords ! !

!SettingTree methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 18:38'!
keywords: aCollectionOfRegExps
	keywords := (aCollectionOfRegExps) asSet! !

!SettingTree methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 18:38'!
maxNameWidth
	^ ((self collector collect: [:p | UITheme current listFont widthOfStringOrText: p value name]) detectMax: [:l | l ]) ifNil: [60]! !

!SettingTree methodsFor: 'menu' stamp: 'alain.plantec 3/23/2009 18:38'!
menu: menu shifted: b 
	"Set up the menu to apply to the receiver's, 
	honoring the #shifted boolean"
	self getCurrentSelection ifNotNil: [:current | current menu: menu shifted: b].
	^ menu! !

!SettingTree methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 22:53'!
nodeClass
	^ self subclassresponsibility ! !

!SettingTree methodsFor: 'updating' stamp: 'alain.plantec 3/23/2009 18:38'!
noteNewSelection: aSelection
	super noteNewSelection: aSelection.
	self changed: #getDescription.
	! !

!SettingTree methodsFor: 'UI' stamp: 'alain.plantec 3/24/2009 23:25'!
open
	| window |
	Cursor wait
		showWhile: [window := StandardWindow new model: self.
			window title: 'Setting tree'.
			self buildWindowIn: window.
			window themeChanged.
			window openInWorld]! !

!SettingTree methodsFor: 'UI' stamp: 'alain.plantec 3/24/2009 16:59'!
packageListViewIn: aWindow
	^ aWindow
				newTextEditorFor: self
				getText: #getViewedPackageNames
				setText: nil.
! !

!SettingTree methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 22:55'!
pragmaHandlerClass
	^ self subclassresponsibility ! !

!SettingTree methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 21:55'!
prepareCollector
	self collector whenChangedSend: #forceRebuild to: self.
! !

!SettingTree methodsFor: 'dependents access' stamp: 'alain.plantec 3/24/2009 22:56'!
release
	collector release.
	treeBuilder release.
	treeBuilder := nil.
	roots := nil.
	collector := nil.
	status := nil.
	viewedPackages := nil.
	searchedText := nil.
	super release.! !

!SettingTree methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 21:52'!
roots
	^ roots ifNil: [roots := self treeBuilder buildTree]
! !

!SettingTree methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 18:38'!
searchedText
	^ searchedText ifNil: [searchedText := '']! !

!SettingTree methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 18:38'!
searchedText: aString
	searchedText := aString.
! !

!SettingTree methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 18:38'!
setDescription: aText
	status reset.
	status nextPutAll: aText.
	self changed: #getDescription
! !

!SettingTree methodsFor: 'UI' stamp: 'alain.plantec 3/23/2009 18:38'!
statusViewIn: aMorph
	| statusView |
	statusView := aMorph
				newTextEditorFor: self
				getText: #getDescription
				setText: #setDescription:.
	^ statusView
 ! !

!SettingTree methodsFor: 'UI' stamp: 'alain.plantec 3/24/2009 09:13'!
toolBarIn: aMorph
	| toolBar |
	toolBar := aMorph newToolbar: {}.
	toolBar addMorphBack: aMorph newToolSpacer.
	toolBar
		addMorphBack: (aMorph
		newButtonFor: self
		getState: nil
		action: #expandAll
		arguments: nil
		getEnabled: nil
		label: 'Expand all' translated
		help: 'Expand all tree nodes' translated).
	toolBar addMorphBack: aMorph newToolSpacer.
	toolBar
		addMorphBack: (aMorph newLabel: 'Search: ' translated).
	toolBar
		addMorphBack: (aMorph
				newTextEntryFor: self
				getText: #searchedText
				setText: #changeSearchedText:
				getEnabled: nil
				help: nil).
	toolBar addMorphBack: aMorph newToolSpacer.
	toolBar
		addMorphBack: (aMorph
		newButtonFor: self
		getState: nil
		action: #choosePackagesIn:
		arguments: {aMorph}
		getEnabled: nil
		label: 'Choose packages' translated
		help: 'Select packages' translated).
	toolBar addMorphBack: aMorph newToolSpacer.

	^ toolBar
! !

!SettingTree methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 10:17'!
treeBuilder
	^ treeBuilder ifNil: [treeBuilder := self treeBuilderClass new requestor: self]! !

!SettingTree methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 10:17'!
treeBuilderClass
	^ SettingTreeBuilder! !

!SettingTree methodsFor: 'UI' stamp: 'alain.plantec 3/23/2009 18:38'!
treeMorphIn: aMorph
	| treeMorph |
	treeMorph := MorphTreeMorph new selectionColor: aMorph theme selectionColor;	
				on: self
				list: #roots
				selected: #getCurrentSelection
				changeSelected: #noteNewSelection:
				menu: #menu:shifted:
				keystroke: #keyStroke:from:;
				 cornerStyle: aMorph preferredCornerStyle;
				borderStyle: (BorderStyle inset width: 1);
				 hResizing: #spaceFill;
				 vResizing: #spaceFill;
				 autoDeselect: true;
				 yourself.
	treeMorph columns: {self maxNameWidth + 30}.
	^ treeMorph
! !

!SettingTree methodsFor: 'updating' stamp: 'alain.plantec 3/25/2009 22:39'!
updateAccordingTo: aFilter 
	self roots do: [ :r | r updateAccordingTo: aFilter ].
	self roots removeAllSuchThat: [ :n | n isEmpty and: [ (aFilter keepHandler: n item) not ] ].
	self updateList! !

!SettingTree methodsFor: 'updating' stamp: 'alain.plantec 3/23/2009 18:38'!
updateList
	self changed: #roots.
	self changed: #getDescription.
	self changed: #getViewedPackageNames
	

	
! !

!SettingTree methodsFor: 'updating' stamp: 'alain.plantec 3/23/2009 18:38'!
updateStatusWith: aMessage
	status nextPutAll: aMessage.
	status nextPut: Character cr.
! !

!SettingTree methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 18:38'!
viewedPackages
	^ viewedPackages
		ifNil: [viewedPackages := Set new]! !

!SettingTree methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 18:38'!
viewedPackages: aCollectionOfPackagesOrNil
	viewedPackages:= aCollectionOfPackagesOrNil! !

SettingTree subclass: #SystemMenuTree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Menu-Browser'!

!SystemMenuTree methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 00:06'!
keywords
	^ keywords ifNil: [keywords := #('worldMenu') asSet]! !

!SystemMenuTree methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 21:32'!
nodeClass
	^ SystemMenuTreeNode! !

!SystemMenuTree methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 23:05'!
pragmaHandlerClass
	^ SettingHandler! !

!SystemMenuTree methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 10:18'!
treeBuilderClass
	^ SettingMenuTreeBuilder! !

SettingTree subclass: #SystemSettingTree
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

!SystemSettingTree methodsFor: 'menu' stamp: 'alain.plantec 3/20/2009 14:42'!
about
	self inform: 'Here you can browse, query and set all system settings.'! !

!SystemSettingTree methodsFor: 'menu' stamp: 'alain.plantec 3/20/2009 16:17'!
browseInternalSettings
	(SettingTree forKeywords: {self internalSettingKeyword}) open! !

!SystemSettingTree methodsFor: 'menu' stamp: 'alain.plantec 3/20/2009 14:42'!
browseStyle
	| allStyleClasses cls |
	allStyleClasses := (SettingStyle allSubclasses asSortedCollection: [:a :b | a name < b name]) asOrderedCollection.
	cls := UIManager default chooseFrom: (allStyleClasses collect: [:c | c styleName]) values: allStyleClasses.
	cls ifNotNil: [ToolSet browse: cls selector: #load]! !

!SystemSettingTree methodsFor: 'menu' stamp: 'alain.plantec 3/23/2009 10:31'!
buildDefaultStyle
	| code |
	code := 	code := self styleLoadCode: true.
	SettingStyle
		subclass: self defaultSettingStyleClassName
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: SettingStyle category.
	self defaultSettingStyleClass compile: code classified: #loading.
	self defaultSettingStyleClass class
		compile: (('styleName\	^ ''Default'' translated') withCRs)
		classified: #accessing! !

!SystemSettingTree methodsFor: 'menu' stamp: 'alain.plantec 3/20/2009 14:42'!
buildUserDefinedStyleNamed: aName classname: aClassname code: loadCode
	SettingStyle
		subclass: aClassname
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: (SettingSettings userStylePackageNamePrefix value asIdentifier: true), '-Setting-Styles'.
	(Smalltalk at: aClassname) 
		compile: loadCode
		classified: #loading.
	(Smalltalk at: aClassname) class
		compile: ('styleName\	^ ''', aName, '''') withCRs
		classified: #accessing! !

!SystemSettingTree methodsFor: 'UI' stamp: 'alain.plantec 3/21/2009 02:25'!
buildWindowIn: aWindow verticalGap: startGap 
	| menuBar menuBarY |
	menuBar := self menuBarIn: aWindow.
	menuBarY := menuBar minExtent y.
	aWindow 
		addMorph: menuBar
		fullFrame: (LayoutFrame 
				fractions: (0 @ 0 corner: 1 @ 0)
				offsets: (0 @ startGap corner: 0 @ menuBarY)).
	super 
		buildWindowIn: aWindow
		verticalGap: menuBarY + startGap! !

!SystemSettingTree methodsFor: 'UI' stamp: 'alain.plantec 3/24/2009 16:57'!
configurationMenuIn: aWindow
	| configurationMenu |
	configurationMenu := aWindow newMenu.
	configurationMenu
		addToggle: 'Browse internal settings' translated
		target: self
		selector: #browseInternalSettings.
	configurationMenu lastItem font: aWindow theme menuFont.
	configurationMenu
		addToggle: 'Build default style' translated
		target: self
		selector: #buildDefaultStyle.
	configurationMenu lastItem font: aWindow theme menuFont.
	^ configurationMenu! !

!SystemSettingTree methodsFor: 'accessing' stamp: 'alain.plantec 3/20/2009 14:42'!
defaultSettingStyleClass
	^ Smalltalk at: self defaultSettingStyleClassName ifAbsent: []! !

!SystemSettingTree methodsFor: 'accessing' stamp: 'alain.plantec 3/20/2009 14:42'!
defaultSettingStyleClassName
	^ #DefaultSettingStyle! !

!SystemSettingTree methodsFor: 'menu' stamp: 'alain.plantec 3/20/2009 14:42'!
exampleText
	^ 'The simplest:
Definition of the boolean setting "newbyMode" with only a label and a default value:
------------------
MyClass class>>newbyMode
	<setting>
	^ NewbyMode 
			ifNil: [NewbyMode := 
							(SettingManager newSetting: ''Newby mode'') 
							default: false].
------------------
						
One can add a helpful description: 			
------------------
MyClass class>>newbyMode
	<setting>
	^ NewbyMode 
			ifNil: [NewbyMode := 
							(SettingManager newSetting: ''Newby mode'') 
							default: false].
------------------

Classify a bit more:
Settings are organized as a tree. Each setting can be used as the parent of another setting.
The simplest way is to use an empty node (that is a node with no setting) and to define some settings 
with this empty node as a parent.

Here is an empty node "uiSettingNode". Note that there is no need for a class variable.
------------------
MyClass class>>uiSettingNode
	<setting>
	^ (SettingManager newNode: ''UI'') description: ''User interface settings'' 
------------------
and a child setting for it:
------------------
MyClass class>>gradientButtonLook
	<setting>
	^ GradientButtonLook
		ifNil: [GradientButtonLook := 
						(SettingManager newSetting: ''Gradient look for buttons'')
						parent: #uiSettingNode;
						default: true]
------------------
'! !

!SystemSettingTree methodsFor: 'menu' stamp: 'alain.plantec 3/20/2009 14:42'!
examples
	"Open up a workspace with explanatory info in it about the Preference Browser"
	(Workspace new 
		contents: self exampleText;
		openLabel: 'Setting examples') extent: 800@600! !

!SystemSettingTree methodsFor: 'accessing' stamp: 'alain.plantec 3/20/2009 14:42'!
getCodeText
	^ self getCurrentSelection
		ifNil: ['']
		ifNotNil: [:s | 
			| code | 
			code := s item realReceiver class
						sourceCodeAt: s item selector 
						ifAbsent: [''].
			code
				ifEmpty: [''] 
				ifNotEmpty: [s item receiver name , '>>' , code]]! !

!SystemSettingTree methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 18:27'!
getDescription
	^ self getCurrentSelection
		ifNil: [super getDescription]
		ifNotNil: [:selection | Text
				streamContents: [:s |
					s nextPutAll: super getDescription.
					(selection item value respondsTo: #defaultValue)
						ifTrue: [s nextPut: Character cr;
								 nextPutAll: 'Default: ['.
								 selection item value defaultValue settingStoreOn: s.
								 s nextPut: $]]]]! !

!SystemSettingTree methodsFor: 'menu' stamp: 'alain.plantec 3/20/2009 14:42'!
help
	"Open up a workspace with explanatory info in it about the Preference Browser"
	Workspace new
		contents: self helpText;
		openLabel: 'Settings help'! !

!SystemSettingTree methodsFor: 'UI' stamp: 'alain.plantec 3/24/2009 16:57'!
helpMenuIn: aWindow
	| helpMenu |
	helpMenu := aWindow newMenu.
	helpMenu
		addToggle: 'About' translated
		target: self
		selector: #about.
	helpMenu lastItem font: aWindow theme menuFont.
	helpMenu
		addToggle: 'Help' translated
		target: self
		selector: #help.
	helpMenu lastItem font: aWindow theme menuFont.
	helpMenu
		addToggle: 'Examples' translated
		target: self
		selector: #examples.
	helpMenu lastItem font: aWindow theme menuFont.
	^ helpMenu
! !

!SystemSettingTree methodsFor: 'menu' stamp: 'alain.plantec 3/20/2009 14:42'!
helpText
	^ 'To be set later'! !

!SystemSettingTree methodsFor: 'accessing' stamp: 'alain.plantec 3/20/2009 16:17'!
internalSettingKeyword
	^ #internalSetting! !

!SystemSettingTree methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 22:54'!
keywords
	^ keywords ifNil: [keywords := #('setting') asSet]! !

!SystemSettingTree methodsFor: 'menu' stamp: 'alain.plantec 3/20/2009 14:42'!
loadStyle
	| allStyleClasses cls |
	allStyleClasses := (SettingStyle allSubclasses asSortedCollection: [:a :b | a name < b name]) asOrderedCollection.
	cls := UIManager default chooseFrom: (allStyleClasses collect: [:c | c styleName]) values: allStyleClasses.
	cls ifNotNil: [cls new load]! !

!SystemSettingTree methodsFor: 'UI' stamp: 'alain.plantec 3/24/2009 16:57'!
menuBarIn: aWindow
	| menuBar |
	menuBar := aWindow newToolDockingBar.
	menuBar
		add: 'Style' translated
		font: aWindow theme menuBarFont
		icon: nil
		help: 'Style creation, loading or removal operations' translated
		subMenu: (self styleMenuIn: aWindow).
	menuBar
		add: 'Configuration' translated
		font: aWindow theme menuBarFont
		icon: nil
		help: nil
		subMenu: (self configurationMenuIn: aWindow).
	menuBar addSpacer.
	menuBar
		add: 'Help' translated
		font: aWindow theme menuBarFont
		icon: nil
		help: nil
		subMenu: (self helpMenuIn: aWindow).
	^ menuBar
! !

!SystemSettingTree methodsFor: 'menu' stamp: 'alain.plantec 3/20/2009 16:05'!
newStyle
	| name clsName usedName |
	name := UIManager default request: 'Give the new style name.' translated initialAnswer: 'MyOwn'.
	name
		ifNotEmpty: [
			usedName := ''.
			name subStrings do: [:s | s at: 1 put: (s first asUppercase). usedName := usedName, s].
			clsName := ((usedName
						, (SettingSettings styleNameClassSuffix value)) asIdentifier: true) asSymbol.
			(Smalltalk
						at: clsName
						ifAbsent: [])
				ifNotNil: [:cls | World alert: clsName , ' ' , 'already exists, sorry' translated title: 'Invalid new style name' translated].
			self buildUserDefinedStyleNamed: name classname: clsName code: (self styleLoadCode: false)]! !

!SystemSettingTree methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 22:53'!
nodeClass
	^ SystemSettingTreeNode! !

!SystemSettingTree methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 22:52'!
pragmaHandlerClass
	^ SystemSettingHandler! !

!SystemSettingTree methodsFor: 'menu' stamp: 'alain.plantec 3/20/2009 14:42'!
removeStyle
	| allStyleClasses cls |
	allStyleClasses := (SettingStyle allSubclasses asSortedCollection: [:a :b | a name < b name]) asOrderedCollection.
	allStyleClasses remove: self defaultSettingStyleClass.
	cls := UIManager default chooseFrom: (allStyleClasses collect: [:c | c styleName]) values: allStyleClasses.
	cls ifNotNil: [(UIManager confirm: 'Definitively remove style' translated,' "', cls styleName, '" ?')
		ifTrue: [Smalltalk removeClassNamed: cls name]]! !

!SystemSettingTree methodsFor: 'menu' stamp: 'alain.plantec 3/23/2009 18:25'!
styleLoadCode: forDefault 
	^ String
		streamContents: [:s | 
			s nextPutAll: 'load';
				 nextPut: Character cr.
			(self collector
				select: [:d | d value hasValue])
				do: [:d | 
					s nextPutAll: d realReceiver name;
						 nextPut: Character space;
						 nextPutAll: d selector;
						 nextPut: Character space;
						 nextPutAll: 'value: ';
						 nextPut: Character space.
					forDefault
						ifTrue: [d value defaultValue settingStoreOn: s]
						ifFalse: [d value value settingStoreOn: s].
					s nextPut: $.;
						 nextPut: Character cr]]! !

!SystemSettingTree methodsFor: 'UI' stamp: 'alain.plantec 3/24/2009 16:58'!
styleMenuIn: aWindow
	| styleMenu |
	styleMenu := aWindow newMenu.
	styleMenu
		addToggle: 'New' translated
		target: self
		selector: #newStyle.
	styleMenu lastItem font: aWindow theme menuFont.
	styleMenu
		addToggle: 'Update' translated
		target: self
		selector: #updateStyle.
	styleMenu lastItem font: aWindow theme menuFont.
	styleMenu
		addToggle: 'Load' translated
		target: self
		selector: #loadStyle.
	styleMenu lastItem font: aWindow theme menuFont.
	styleMenu
		addToggle: 'Browse' translated
		target: self
		selector: #browseStyle.
	styleMenu lastItem font: aWindow theme menuFont.
	styleMenu
		addToggle: 'remove' translated
		target: self
		selector: #removeStyle.
	styleMenu lastItem font: aWindow theme menuFont.
	^ styleMenu! !

!SystemSettingTree methodsFor: 'accessing' stamp: 'alain.plantec 3/20/2009 14:42'!
taskbarIcon
	^ MenuIcons smallConfigurationIcon! !

!SystemSettingTree methodsFor: 'menu' stamp: 'alain.plantec 3/20/2009 14:42'!
updateStyle
	| allStyleClasses cls |
	allStyleClasses := (SettingStyle allSubclasses asSortedCollection: [:a :b | a name < b name]) asOrderedCollection.
	cls := UIManager default chooseFrom: (allStyleClasses collect: [:c | c styleName]) values: allStyleClasses.
	cls ifNotNil: [self buildUserDefinedStyleNamed: cls styleName classname: cls name code: (self styleLoadCode: false)]! !

!Object methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/24/2009 23:21'!
settingFixedDomainValueNodeFrom: aSettingNode 
	^ aSettingNode fixedDomainValueNodeForObject: self! !

!Object methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/19/2009 09:50'!
settingStoreOn: aStream
	^ self storeOn: aStream! !

Object subclass: #PragmaCollector
	instanceVariableNames: 'requestor announcer collected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Pragma'!

!PragmaCollector commentStamp: 'alain.plantec 3/25/2009 22:58' prior: 0!
A PragmaCollector is able to store all pragmas according to a rule implemented by the #keepPragma method.
The contents is made of a collection of PragmaHandler instances.
A PragmaCollector makes use of the SystemChangeNotifier event notification in order to maintain its contents:
when a method is added, removed or updated, if the related method contains a pragma then the collector contents 
is eventually updated. A PragmaCollector makes use of an annoucer in order to notify when a pragma handler 
is added, removed or updated.
A PragmaCollector is always associated with a client object: the requestor. the requestor must implement #keepPragma 
and #handlerClass methods.


Instance Variables
	announcer:		<Announcer>
	collected:		<Collection of PragmaHandler>
	requestor:		<Object>

!

!PragmaCollector class methodsFor: 'instance creation' stamp: 'alain.plantec 3/23/2009 08:51'!
requestor: aRequestor
	^ self new requestor: aRequestor! !

!PragmaCollector methodsFor: 'updating' stamp: 'alain.plantec 3/21/2009 14:54'!
addHandler: aPragmaHandler
	self collected add: aPragmaHandler.
	self announce: (PragmaRegistered new handler: aPragmaHandler)! !

!PragmaCollector methodsFor: 'updating' stamp: 'alain.plantec 3/22/2009 16:09'!
addHandlerFromPragma: aPragma
	self addHandler: (self handlerClass pragma: aPragma). 
! !

!PragmaCollector methodsFor: 'system changes' stamp: 'alain.plantec 3/22/2009 23:07'!
addedEventOccurs: anEvent 
	Pragma 
		withPragmasIn: anEvent itemClass
		do: 
			[ :pragma | 
			pragma selector = anEvent itemSelector ifTrue: 
				[ (self keepPragma: pragma) ifTrue: [ self addHandlerFromPragma: pragma ] ] ]! !

!PragmaCollector methodsFor: 'querying' stamp: 'alain.plantec 3/22/2009 23:07'!
allAcceptablePragmas
	^ (Array streamContents: 
		[ :stream | 
		SystemNavigation default allBehaviorsDo: 
			[ :behavior | 
			Pragma 
				withPragmasIn: behavior
				do: [ :pragma | (self keepPragma: pragma) ifTrue: [ stream nextPut: pragma ] ] ] ]) asOrderedCollection! !

!PragmaCollector methodsFor: 'subscription' stamp: 'alain.plantec 3/26/2009 14:31'!
announce: anAnnouncement
	self announcer ifNotNil: [announcer announce: anAnnouncement]! !

!PragmaCollector methodsFor: 'accessing' stamp: 'alain.plantec 3/21/2009 09:49'!
announcer
	^ announcer! !

!PragmaCollector methodsFor: 'system changes' stamp: 'alain.plantec 3/22/2009 10:14'!
classRemovedEventOccurs: anEvent 
	anEvent itemClass theNonMetaClass = self class
		ifTrue: [^ self noMoreNotifications].
	(self handlersOfClass: anEvent itemClass theNonMetaClass)
		do: [:handler | self removeHandler: handler] ! !

!PragmaCollector methodsFor: 'enumerating' stamp: 'alain.plantec 3/21/2009 10:10'!
collect: aBlock
	^ self collected collect: aBlock
	! !

!PragmaCollector methodsFor: 'accessing' stamp: 'alain.plantec 3/21/2009 10:04'!
collected
	^ collected ifNil: [collected := OrderedCollection new]! !

!PragmaCollector methodsFor: 'accessing' stamp: 'alain.plantec 3/22/2009 11:04'!
collectedPragmas
	^ self collect: [:handler | handler pragma]! !

!PragmaCollector methodsFor: 'enumerating' stamp: 'alain.plantec 3/21/2009 10:11'!
detect: aBlock
	^ self collected detect: aBlock ifNone:[]
	! !

!PragmaCollector methodsFor: 'enumerating' stamp: 'alain.plantec 3/21/2009 10:11'!
do: aBlock
	self collected do: aBlock
	! !

!PragmaCollector methodsFor: 'system changes' stamp: 'alain.plantec 3/26/2009 14:45'!
event: anEvent 
	"Hook for SystemChangeNotifier: 
	automatically updates the system settings when a
	method is added, removed or updated or when a
	class is removed
	"
	requestor class isObsolete
		ifFalse: [(anEvent itemKind = SystemChangeNotifier classKind
					and: [anEvent isRemoved])
				ifTrue: [^ self classRemovedEventOccurs: anEvent].
			anEvent itemKind = SystemChangeNotifier methodKind
				ifTrue: [anEvent isRemoved
						ifTrue: [^ self removedEventOccurs: anEvent]. 
					anEvent isAdded
						ifTrue: [^ self addedEventOccurs: anEvent].
					anEvent isModified
						ifTrue: [^ self modifiedEventOccurs: anEvent]]]! !

!PragmaCollector methodsFor: 'accessing' stamp: 'alain.plantec 3/22/2009 16:08'!
handlerClass
	^ requestor isNil ifTrue: [PragmaHandler] ifFalse: [requestor pragmaHandlerClass]! !

!PragmaCollector methodsFor: 'querying' stamp: 'alain.plantec 3/21/2009 15:39'!
handlerOf: aSelector inClass: aClass 
	"return the handler corresponding to a pragma method which selector is aSelector in class aClass"
	^ (self detect: [:handler | handler methodClass = aClass theNonMetaClass and: [handler selector = aSelector]])
	! !

!PragmaCollector methodsFor: 'querying' stamp: 'alain.plantec 3/21/2009 15:33'!
handlersOfClass: aClass 
	"return all handlers of class aClass"
	^ self	select: [:handler | handler methodClass = aClass theNonMetaClass]! !

!PragmaCollector methodsFor: 'testing' stamp: 'alain.plantec 3/22/2009 10:17'!
ifNotEmpty: aBlock
	self collected ifNotEmpty: aBlock! !

!PragmaCollector methodsFor: 'initializing' stamp: 'alain.plantec 3/22/2009 10:56'!
initialize
	super initialize.
	announcer := Announcer new.
	self installSystemNotifications! !

!PragmaCollector methodsFor: 'system changes' stamp: 'alain.plantec 3/22/2009 10:56'!
installSystemNotifications
	SystemChangeNotifier uniqueInstance 
		notify: self
		ofAllSystemChangesUsing: #event:! !

!PragmaCollector methodsFor: 'testing' stamp: 'alain.plantec 3/22/2009 10:17'!
isEmpty
	^ self collected isEmpty! !

!PragmaCollector methodsFor: 'testing' stamp: 'alain.plantec 3/22/2009 10:17'!
isNotEmpty
	^ self collected isNotEmpty! !

!PragmaCollector methodsFor: 'testing' stamp: 'alain.plantec 3/22/2009 23:07'!
keepPragma: aPragma 
	^ requestor isNil or: [ requestor keepPragma: aPragma ]! !

!PragmaCollector methodsFor: 'system changes' stamp: 'alain.plantec 3/26/2009 14:48'!
modifiedEventOccurs: anEvent 
	"
	try to update an handler:
	1 - I already have one for aSelector and aClass, then
	do nothing, one have to reset defaults
	2 - I have one but changed method has no more
	acceptable pragma in it, but let handler alive (it can
	have listeners).
	3 - I do not have one but method has an acceptable
	pragma in it, then I try to add a new handler
	"
	Pragma 
		withPragmasIn: anEvent itemClass
		do: 
			[ :pragma | 
			pragma selector = anEvent itemSelector ifTrue: 
				[ (self detect: 
					[ :handler | 
					handler selector = pragma selector and: [ handler methodClass theNonMetaClass = anEvent itemClass theNonMetaClass] ]) ifNotNil: [ :handler | ^ self updateHandler: handler ].
				(self keepPragma: pragma) ifTrue: [ ^ self addHandlerFromPragma: pragma ] ] ]! !

!PragmaCollector methodsFor: 'system changes' stamp: 'alain.plantec 3/26/2009 14:33'!
noMoreAnnounceWhile: aBlock 
	| oldAnnouncer |
	[oldAnnouncer := announcer.
	announcer := nil.
	aBlock value]
		ensure: [announcer := oldAnnouncer]! !

!PragmaCollector methodsFor: 'system changes' stamp: 'alain.plantec 3/22/2009 10:08'!
noMoreNotifications
		SystemChangeNotifier uniqueInstance noMoreNotificationsFor: self
! !

!PragmaCollector methodsFor: 'system changes' stamp: 'alain.plantec 3/22/2009 10:56'!
noMoreNotificationsWhile: aBlock 
	self noMoreNotifications.
	[ aBlock value ] ensure: [ self installSystemNotifications ]! !

!PragmaCollector methodsFor: 'enumerating' stamp: 'alain.plantec 3/21/2009 10:11'!
noneSatisfy: aBlock
	^ self collected noneSatisfy: aBlock! !

!PragmaCollector methodsFor: 'enumerating' stamp: 'alain.plantec 3/21/2009 10:11'!
reject: aBlock
	^ self collected reject: aBlock ! !

!PragmaCollector methodsFor: 'dependents access' stamp: 'alain.plantec 3/23/2009 11:11'!
release
	self noMoreNotifications.
	announcer := nil.
	requestor := nil.
	collected := nil.
	super release.! !

!PragmaCollector methodsFor: 'updating' stamp: 'alain.plantec 3/26/2009 14:35'!
removeHandler: aPragmaHandler 
	self collected remove: aPragmaHandler.
	self announce: (PragmaUnregistered new handler: aPragmaHandler)! !

!PragmaCollector methodsFor: 'system changes' stamp: 'alain.plantec 3/26/2009 14:43'!
removedEventOccurs: anEvent 
	(self
				detect: [:handler | handler selector = anEvent itemSelector
						and: [handler methodClass theNonMetaClass = anEvent itemClass theNonMetaClass]])
		ifNotNil: [:found | self removeHandler: found]! !

!PragmaCollector methodsFor: 'accessing' stamp: 'alain.plantec 3/21/2009 21:07'!
requestor: aRequestor
	requestor := aRequestor! !

!PragmaCollector methodsFor: 'initializing' stamp: 'alain.plantec 3/26/2009 14:33'!
reset
	"reinitialize current system settings"
	self noMoreAnnounceWhile: [
		self collected copy do: [:handler | self removeHandler: handler].
		self allAcceptablePragmas
			do: [:pragma | self addHandlerFromPragma: pragma]].
	self announce: PragmaCollectorReinitialized.! !

!PragmaCollector methodsFor: 'enumerating' stamp: 'alain.plantec 3/21/2009 10:11'!
select: aBlock
	^ self collected select: aBlock
	! !

!PragmaCollector methodsFor: 'subscription' stamp: 'alain.plantec 3/21/2009 15:40'!
subscribe: anAnnouncement send: aSelector to: anObject
	self announcer subscribe: anAnnouncement send: aSelector to: anObject

! !

!PragmaCollector methodsFor: 'subscription' stamp: 'alain.plantec 3/22/2009 10:57'!
unsubscribe: anObject
	self announcer unsubscribe: anObject

! !

!PragmaCollector methodsFor: 'updating' stamp: 'alain.plantec 3/21/2009 15:52'!
updateHandler: aPragmaHandler 
	self announcer announce: (PragmaUpdated new handler: aPragmaHandler)! !

!PragmaCollector methodsFor: 'subscription' stamp: 'alain.plantec 3/26/2009 14:38'!
whenChangedSend: aSelector to: anObject
	self subscribe: PragmaHandlerAnnouncement send: aSelector to: anObject
! !

Object subclass: #PragmaHandler
	instanceVariableNames: 'pragma'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Pragma'!

!PragmaHandler commentStamp: 'alain.plantec 3/25/2009 22:48' prior: 0!
A PragmaHandler stores a pragma. Is used used by PragmaCollector: PragmaCollector contents is made of a collection of PragmaHandler.

Instance Variables
	pragma:		<Pragma>

!

!PragmaHandler classSide methodsFor: 'instance creation' stamp: 'alain.plantec 3/22/2009 11:07'!
pragma: aPragma
	^ self new pragma: aPragma
! !

!PragmaHandler methodsFor: 'tools' stamp: 'alain.plantec 3/23/2009 10:12'!
browseDeclaration
	ToolSet browse: self methodClass selector: self selector! !

!PragmaHandler methodsFor: 'accessing' stamp: 'alain.plantec 3/22/2009 10:35'!
keyword
	^ pragma keyword! !

!PragmaHandler methodsFor: 'accessing' stamp: 'alain.plantec 3/22/2009 11:29'!
method
	^ pragma method! !

!PragmaHandler methodsFor: 'accessing' stamp: 'alain.plantec 3/21/2009 23:59'!
methodClass
	^ pragma methodClass! !

!PragmaHandler methodsFor: 'accessing' stamp: 'alain.plantec 3/22/2009 11:31'!
methodReference
	^ self method ifNotNil: [:m | m methodReference]! !

!PragmaHandler methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 08:40'!
package
	^ PackageOrganizer default
				mostSpecificPackageOfClass: self methodClass
				ifNone: []! !

!PragmaHandler methodsFor: 'accessing' stamp: 'alain.plantec 3/21/2009 10:02'!
pragma
	^ pragma! !

!PragmaHandler methodsFor: 'accessing' stamp: 'alain.plantec 3/21/2009 10:03'!
pragma: aPragma
	pragma := aPragma! !

!PragmaHandler methodsFor: 'accessing' stamp: 'alain.plantec 3/21/2009 23:59'!
selector
	^ pragma selector! !

PragmaHandler subclass: #SettingHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

!SettingHandler methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 09:23'!
description
	^ self value description! !

!SettingHandler methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 08:42'!
signature
	^ self methodClass printString, '>>', self selector! !

!SettingHandler methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 09:17'!
value
	^ self methodClass isObsolete ifFalse: [self methodClass theNonMetaClass perform: self selector]! !

SettingHandler subclass: #SystemSettingHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

!SystemSettingHandler methodsFor: 'valueHandling' stamp: 'alain.plantec 3/24/2009 22:50'!
setToDefault
	self value ifNotNil: [:v | v setToDefault]! !

Object subclass: #PragmaSetting
	instanceVariableNames: 'name parent description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

PragmaSetting subclass: #MenuSettingNode
	instanceVariableNames: 'line order enablement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Menu-Core'!

MenuSettingNode subclass: #MenuElement
	instanceVariableNames: 'target selector state arguments icon'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Menu-Core'!

!MenuElement methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 15:56'!
arguments
	^ arguments ifNil: [#()]! !

!MenuElement methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 20:46'!
arguments: aCollection
	arguments := aCollection! !

!MenuElement methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 10:13'!
children
	^#()! !

!MenuElement methodsFor: 'testing' stamp: 'alain.plantec 3/26/2009 11:12'!
enabled
	^ self enablement! !

!MenuElement methodsFor: 'accessing' stamp: 'alain.plantec 3/26/2009 11:13'!
icon
	^ icon value! !

!MenuElement methodsFor: 'accessing' stamp: 'alain.plantec 3/26/2009 11:13'!
icon: aValuable
	icon := aValuable! !

!MenuElement methodsFor: 'menu assembling' stamp: 'alain.plantec 3/26/2009 08:51'!
menuItemIn: aMenu 
	| newItem |
	aMenu
		addToggle: self name
		target: self target value
		selector: self selector
		getStateSelector: self state
		enablementSelector: self enablement
		argumentList: self arguments.
	newItem := aMenu lastItem.
	newItem icon: self icon.
	newItem setBalloonText: description.
	self line ifTrue: [aMenu addLine].
	^ newItem
! !

!MenuElement methodsFor: 'accessing' stamp: 'alain.plantec 3/26/2009 11:14'!
selector
	^ selector value! !

!MenuElement methodsFor: 'accessing' stamp: 'alain.plantec 3/26/2009 11:14'!
selector: aValuable
	selector := aValuable! !

!MenuElement methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 20:47'!
state
	^ state! !

!MenuElement methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 20:48'!
state: aSymbol
	state := aSymbol! !

!MenuElement methodsFor: 'menu assembling' stamp: 'alain.plantec 3/26/2009 08:51'!
subMenuItemIn: aMenu 
	| sub |
	sub := MenuMorph new.
	aMenu
		add: self name
		subMenu: sub
		target: self target value
		selector: self selector
		argumentList: self arguments.
	aMenu lastItem icon: self icon.
	aMenu lastItem setBalloonText: description.
	self line ifTrue: [aMenu addLine].

	self line ifTrue: [aMenu addLine].
	^ sub! !

!MenuElement methodsFor: 'accessing' stamp: 'alain.plantec 3/26/2009 11:15'!
target
	^ target value! !

!MenuElement methodsFor: 'accessing' stamp: 'alain.plantec 3/26/2009 11:15'!
target: aValuable
	target := aValuable! !

!MenuSettingNode methodsFor: 'accessing' stamp: 'alain.plantec 3/26/2009 11:12'!
enablement
	^ enablement value ifNil: [true]! !

!MenuSettingNode methodsFor: 'accessing' stamp: 'alain.plantec 3/26/2009 11:12'!
enablement: aValuable 
	enablement := aValuable! !

!MenuSettingNode methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 22:12'!
line
	^ line ifNil: [line := false]! !

!MenuSettingNode methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 22:12'!
line: aBoolean
	line := aBoolean! !

!MenuSettingNode methodsFor: 'accessing' stamp: 'alain.plantec 3/26/2009 11:18'!
order
	^ order ifNil: [order := 0]! !

!MenuSettingNode methodsFor: 'accessing' stamp: 'alain.plantec 3/26/2009 11:10'!
order: aNumber
	order := aNumber! !

MenuSettingNode subclass: #MenuSiblings
	instanceVariableNames: 'menus'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Menu-Core'!

!MenuSiblings methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 10:13'!
children
	^ menus! !

!MenuSiblings methodsFor: 'menu assembling' stamp: 'alain.plantec 3/26/2009 09:58'!
menuItemIn: aMenu 
	| sub item |
	name
		ifNil: [sub := aMenu]
		ifNotNil: [item := MenuItemMorph new.
			sub := MenuMorph new.
			item contents: self name;
				 isEnabled: true;
				 subMenu: sub.
			aMenu addMorphBack: item].
	self children
		do: [:c | 
			c menuItemIn: sub. 
			sub lastItem setBalloonText: description].
	self line
		ifTrue: [aMenu addLine].
	^ sub! !

!MenuSiblings methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 00:07'!
menus
	^ menus! !

!MenuSiblings methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 00:13'!
menus: aCollectionOfMenuSettings
	menus := aCollectionOfMenuSettings.
	aCollectionOfMenuSettings do: [:s | s parent: self parent].
	! !

!PragmaSetting methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/11/2009 15:38'!
asString
	^ self name! !

!PragmaSetting methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 19:36'!
description
	"Answer the value of description"

	^ description ifNil: [description := self name]! !

!PragmaSetting methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 19:36'!
description: aText
	"Set the value of description"

	description := aText! !

!PragmaSetting methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/12/2009 12:58'!
enabled
	^ true! !

!PragmaSetting methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/4/2009 11:33'!
icon
	^ MenuIcons smallConfigurationIcon! !

!PragmaSetting methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/12/2009 17:15'!
inputMorphFor: aContainer 
	^ self inputWidget
		ifNotNil: [:iw | 
			| row | 
			iw model: self.
			row := UITheme current newRowIn: World for: {iw}.
			row hResizing: #rigid;
				 clipSubmorphs: true;
				width: (self inputWidgetWidth: iw);
				 cellInset: 0]! !

!PragmaSetting methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/24/2009 20:55'!
inputWidget
	^ nil! !

!PragmaSetting methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/12/2009 17:13'!
inputWidgetWidth: inputWidget
	^ inputWidget width
! !

!PragmaSetting methodsFor: 'accessing' stamp: 'alain.plantec 3/26/2009 08:31'!
name
	^ name ifNil: [super name]! !

!PragmaSetting methodsFor: 'accessing' stamp: 'alain.plantec 3/4/2009 10:31'!
name: aName
	name := aName! !

!PragmaSetting methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/11/2009 19:58'!
nameMorph
	^ UITheme current windowLabelForText: self name ! !

!PragmaSetting methodsFor: 'accessing' stamp: 'alain.plantec 3/3/2009 15:21'!
parent
	^ parent! !

!PragmaSetting methodsFor: 'accessing' stamp: 'alain.plantec 3/4/2009 10:31'!
parent: anObject
	"Set the value of parent"

	parent := anObject! !

!PragmaSetting methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/12/2009 09:39'!
rowMorphListFor: aContainer
	| controls |
	controls := OrderedCollection with: self nameMorph.
	(self inputMorphFor: aContainer) ifNotNil: [:im | controls add: im].
	^ controls! !

PragmaSetting subclass: #SystemSettingNode
	instanceVariableNames: 'dialog'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

SystemSettingNode subclass: #AbstractSettingValue
	instanceVariableNames: 'realValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!AbstractSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/19/2009 10:06'!
hasValue
	^ true! !

!AbstractSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/5/2009 16:21'!
icon
	^ MenuIcons smallPaintIcon! !

!AbstractSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/11/2009 12:56'!
nameMorph
	^ UITheme current newLabelIn: World for: self label: self name getEnabled: nil! !

!AbstractSettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/4/2009 10:54'!
realValue
	"Answer the value of realValue"

	^ realValue! !

!AbstractSettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/4/2009 10:54'!
realValue: anObject
	"Set the value of realValue"

	realValue := anObject! !

!AbstractSettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/11/2009 08:40'!
value
	^ self realValue value! !

AbstractSettingValue subclass: #FixedSettingValue
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!FixedSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/13/2009 18:36'!
asString
	^ self name! !

!FixedSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/12/2009 21:19'!
icon
	^ MenuIcons smallHelpIcon! !

!FixedSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/24/2009 23:19'!
settingFixedDomainValueNodeFrom: aSettingNode 
	^ self! !

!FixedSettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/11/2009 20:11'!
value: anObject
	^ self realValue: anObject! !

AbstractSettingValue subclass: #SettingValue
	instanceVariableNames: 'type default list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!SettingValue commentStamp: '<historical>' prior: 0!
A SettingValue is an handler for a setting value. 
Its main responsibility is hold descriptive data and to notify all listeners when the setting value is changed.
see #value: method which is call in order to change a setting value.

Instance Variables
	type:			<Object>
	default:		<Object>
	list:		<Object>
!

SettingValue subclass: #FixedMultipleSettingValue
	instanceVariableNames: 'domainValues'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!FixedMultipleSettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/13/2009 09:24'!
default
	^ default ifNil: [default := self domainValues first value]! !

!FixedMultipleSettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/11/2009 14:30'!
domainValues
	^ domainValues ! !

!FixedMultipleSettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 23:19'!
domainValues: aCollection 
	domainValues := aCollection asOrderedCollection collect: [ :v | (v settingFixedDomainValueNodeFrom: self) parent: self ]! !

!FixedMultipleSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/11/2009 16:28'!
dropListValues
	^ self domainValues collect: [:i | i name]! !

!FixedMultipleSettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 23:20'!
fixedDomainValueNodeForAssociation: anAssociation 
	^ (SettingManager newFixed: anAssociation key)
		description: anAssociation key;
		value: anAssociation value! !

!FixedMultipleSettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 23:21'!
fixedDomainValueNodeForObject: anObject 
	^ (SettingManager newFixed: anObject asString)
		description: anObject asString;
		value: anObject! !

!FixedMultipleSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/13/2009 22:55'!
haveEditableList
	^ false! !

!FixedMultipleSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/13/2009 21:14'!
index
	self value ifNil: [self value: self default].
	^ self domainValues indexOf: (self domainValues detect: [:dv | dv value = self value] ifNone: [^ 0])! !

!FixedMultipleSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/13/2009 21:15'!
index: anInteger
	self value: (self domainValues at: anInteger) value.
! !

!FixedMultipleSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/13/2009 18:31'!
inputWidget
	| dropList |
	dropList := UITheme current
				newDropListIn: World
				for: self
				list: #list
				getSelected: #index
				setSelected: #index:
				getEnabled: #enabled
				useIndex: true
				help: self description.
	dropList extent: 1 @ 30.
	^ dropList! !

!FixedMultipleSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/12/2009 09:14'!
inputWidgetWidth: inputWidget
	^ (self maxNameWidthForFont: inputWidget font) + 40

! !

!FixedMultipleSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/13/2009 18:38'!
list
	^ list ifNil: [list := self domainValues collect: [:i | i name]]! !

!FixedMultipleSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/13/2009 18:43'!
maxNameWidthForFont: aFont 
	| max |
	max := 0.
	self list
		do: [:v | max := max max: (aFont widthOfStringOrText: v)].
	^ max ! !

SettingValue subclass: #MultipleSettingValue
	instanceVariableNames: 'getter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!MultipleSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/16/2009 11:09'!
chooseValue
	| chosen |
	chosen := UIManager default
				chooseFrom: self domainValueLabels
				values: (self domainValues asSortedCollection: [:a :b | a asString < b asString])
				title: 'Choose ' translated , self name translated.
	chosen 
		ifNotNil: [self addToList: chosen. self value: chosen. ]! !

!MultipleSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/16/2009 10:54'!
domainValueLabels
	^ (self domainValues collect: [:e | e asString]) asSortedCollection! !

!MultipleSettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/16/2009 10:13'!
domainValues
	^ getter value asOrderedCollection! !

!MultipleSettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/16/2009 09:54'!
getter: aValuable 
	getter := aValuable! !

!MultipleSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/16/2009 09:50'!
haveEditableList
	^ false! !

!MultipleSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/16/2009 11:19'!
inputMorphFor: aContainer 
	| inputMorph label |
	inputMorph := super inputMorphFor: aContainer.
	label := EditableDropListMorph
				on: self
				list: #list
				selected: #index
				changeSelected: #index:
				useIndex: true 
				addToList: nil
				class: nil
				getEnabled: #enabled.
	label height: label font height + 8.
	label width: self maxLabelWidth + 30.
	label contentMorph lock. 
	inputMorph addMorphBack: label.
	inputMorph layoutPolicy: TableLayout new.
	inputMorph hResizing: #shrinkWrap.
	inputMorph cellInset: 10.
	inputMorph fullBounds.
	inputMorph
		submorphsDo: [:sm | sm minHeight: label height].
	^ inputMorph! !

!MultipleSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/16/2009 09:59'!
inputWidget
	^ (UITheme current
		newButtonIn: World
		for: self
		getState: nil
		action: #chooseValue 
		arguments: {}
		getEnabled: #enabled
		getLabel: nil
		help: 'Choose a value for ' translated , self name translated) label: 'Choose...';
		 yourself! !

!MultipleSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/16/2009 10:52'!
maxLabelWidth
	^ (self domainValueLabels collect: [:e | UITheme current textFont widthOfStringOrText: e]) detectMax: [:e | e]
! !

SettingValue subclass: #RangeSettingValue
	instanceVariableNames: 'range'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!RangeSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/13/2009 22:55'!
haveEditableList
	^ false! !

!RangeSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/12/2009 16:47'!
inputMorphFor: aContainer
	| inputMorph textInput |
	inputMorph := super inputMorphFor: aContainer.
	textInput :=  (UITheme current
		newTextEntryIn: World 
		for: self
		get: #value
		set: #value:
		class: (Smalltalk at: self type)
		getEnabled: #enabled
		help: nil) hResizing: #rigid;
		width: 80.
	inputMorph addMorphFront: textInput.
	inputMorph layoutPolicy: TableLayout new.
	inputMorph hResizing: #shrinkWrap.
	inputMorph cellInset: 10.
	inputMorph fullBounds.
	inputMorph submorphsDo: [:sm | sm minHeight: textInput height].
	^ inputMorph
	! !

!RangeSettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/16/2009 14:27'!
inputWidget
	"^ (UITheme current
	newSliderIn: World
	for: self 
	getValue: #value
	setValue: #value:
	min: self range first
	max: self range last
	quantum: self range increment
	getEnabled: #enabled
	help: self description) minWidth: 300; yourself"
	^ (PluggableSliderMorph new max: self range last;
		 min: self range first;
		 quantum: self range increment;
		 on: self
		 getValue: #value
		 setValue: #value:) hResizing: #spaceFill;
		 vResizing: #spaceFIll;
		 setBalloonText: self description;
		 minWidth: 300;
		 yourself! !

!RangeSettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/12/2009 16:19'!
range
	^ range ! !

!RangeSettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/3/2009 09:38'!
range: anInterval
	range := anInterval! !

!RangeSettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/12/2009 16:44'!
value: aValue
	super value: ((aValue max: self range first) min: self range last).
	! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 12:56'!
addToList: anItem 
	(self list includes: anItem)
		ifFalse: [self list size > 5 ifTrue: [self list removeFirst].
			self list add: anItem. 
			self changed: #list]! !

!SettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/2/2009 14:25'!
changeEvent
	^ #valueChanged ! !

!SettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/11/2009 19:40'!
default
	^ default ! !

!SettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/11/2009 19:25'!
default: anObject
	default := anObject.
	realValue := anObject! !

!SettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/4/2009 11:48'!
defaultValue
	^ default value! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/13/2009 23:10'!
emptyList
	list := nil.
	self addToList: self value.
! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/12/2009 15:35'!
enablementChanged
	self changed: #enabled.
! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/12/2009 15:39'!
fontButtonLabel
	| emphases |
	emphases := IdentityDictionary new at: nil put: 'Regular' translated;
				 at: 0 put: 'Regular' translated;
				 at: 1 put: 'Bold' translated;
				 at: 2 put: 'Italic' translated;
				 at: 4 put: 'Underlined' translated;
				 at: 8 put: 'Narrow' translated; 
				 at: 16 put: 'StruckOut' translated;
				 yourself.
	^ StringMorph contents: self value familyName , ' '
			, (emphases
					at: self value emphasis
					ifAbsent: ['']) , ' ' , self value pointSize asString font: self value! !

!SettingValue methodsFor: 'notification' stamp: 'alain.plantec 3/12/2009 12:10'!
forget: aReceiver
	self removeActionsWithReceiver: aReceiver forEvent: self changeEvent.
! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/12/2009 15:39'!
getFont
	^ FontChooser
		openWithWindowTitle: 'Font for ' , self name
		for: self
		setSelector: #value:
		getSelector: #value ! !

!SettingValue methodsFor: 'testing' stamp: 'alain.plantec 3/13/2009 22:45'!
haveDefault
	^ true! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/13/2009 22:55'!
haveEditableList
	^ true! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/16/2009 16:43'!
icon
	^ self type = #LogicalFont ifTrue: [MenuIcons smallFontsIcon]
	ifFalse: [super icon]! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/19/2009 10:17'!
index
	self value
		ifNil: [self list
				ifNotEmpty: [:l | self value: l first]].
	^ self list
		indexOf: self value
		ifAbsent: [self addToList: self value. self list size]! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/13/2009 21:19'!
index: anInteger
	self value: (self list at: anInteger).
! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/12/2009 17:12'!
inputMorphFor: aContainer
	^ (super inputMorphFor: aContainer)
		ifNotNil: [:im | 
				self whenChangedSend: #valueChanged to: self.
				self whenChangedSend: #enablementChanged to: self.
				self whenChangedSend: #innerWidgetChanged to: aContainer.
				im]! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 15:36'!
inputWidget
	| inputWidget |
	inputWidget := self typeClass
						ifNil: [self localInputWidgetSelector 
							ifNotNil: [:localSel | self perform: localSel]]
						ifNotNil: [:cls | (self inputWidgetSelectorInClass: cls)
							ifNotNil: [:selector | cls perform: selector with: self]].
	inputWidget
		ifNotNil: [inputWidget model: self].
	^ inputWidget! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/12/2009 15:59'!
inputWidgetForBoolean
	^ UITheme current
			newCheckboxIn: World
			for: self
			getSelected: #value
			setSelected: #value:
			getEnabled: #enabled
			label: '' 
			help: nil! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/12/2009 16:55'!
inputWidgetForColor
	^ (UITheme current
		newColorChooserIn: World
		for: self
		getColor: #value
		setColor: #value:
		getEnabled: #enabled 
		help: 'Choose a color') minWidth: 150; yourself! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 14:49'!
inputWidgetForFont
	^ UITheme current
		newButtonIn: World
		for: self
		getState: nil 
		action: #getFont
		arguments: {}
		getEnabled: #enabled
		getLabel: #fontButtonLabel
		help: 'Choose a font ...' translated
! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 15:05'!
inputWidgetForNumber
	^ self inputWidgetForString width: 200.
! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 15:03'!
inputWidgetForString
	| widget |
	widget := EditableDropListMorph
				on: self
				list: #list
				selected: #index
				changeSelected: #index:
				useIndex: true 
				addToList: #addToList:
				class: (Smalltalk at: self type)
				getEnabled: #enabled.
	widget height: widget font height + 8;
		width: 450.
	^ widget! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 15:34'!
inputWidgetSelectorInClass: aClass
	| selector |
	^ (aClass respondsTo: (selector := #settingInputWidgetForNode:)) ifTrue: [selector]! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/13/2009 21:31'!
list
	^ list
		ifNil: [list := OrderedCollection new.
			self default ifNotNil: [:d | list add: d value].
			list] ! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 15:33'!
localInputWidgetSelector
	| imSel |
	^ (self respondsTo: (imSel := ('inputWidgetFor' , self type) asSymbol)) ifTrue: [imSel]! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/13/2009 22:41'!
setToDefault
	self value: self defaultValue! !

!SettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/11/2009 18:39'!
type
	"Answer the value of type"

	^ type ifNil: [type := self value class name]! !

!SettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/11/2009 18:22'!
type: anObject
	"Set the value of type"

	type := anObject! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/18/2009 15:12'!
typeClass
	^ Smalltalk at: self type ifAbsent: []
! !

!SettingValue methodsFor: 'accessing' stamp: 'alain.plantec 3/12/2009 12:11'!
value: anObject 
	realValue ~= anObject
		ifTrue: [realValue := anObject.
			self triggerEvent: self changeEvent with: anObject]! !

!SettingValue methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/13/2009 18:13'!
valueChanged
	self changed: #value.
	self changed: #fontButtonLabel.
	self changed: #index.
	self changed: #content.
! !

!SettingValue methodsFor: 'notification' stamp: 'alain.plantec 3/12/2009 04:59'!
whenChangedSend: zeroOrOneArgSelector to: aSubscriber
	self when: self changeEvent send: zeroOrOneArgSelector to: aSubscriber! !

!SystemSettingNode methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 20:42'!
dialog
	^ dialog! !

!SystemSettingNode methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 20:42'!
dialog: aSymbol
	dialog := aSymbol! !

!SystemSettingNode methodsFor: 'testing' stamp: 'alain.plantec 3/24/2009 20:52'!
hasValue
	^ false! !

!SystemSettingNode methodsFor: 'testing' stamp: 'alain.plantec 3/24/2009 20:52'!
haveDefault
	^ false! !

!SystemSettingNode methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/24/2009 20:53'!
haveEditableList
	^ false! !

!SystemSettingNode methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/24/2009 20:54'!
inputWidget
	^ (self dialog notNil
			and: [(Smalltalk
					at: self dialog
					ifAbsent: []) notNil])
		ifTrue: [(UITheme current
				newButtonIn: World
				for: self
				getState: nil
				action: #openDialog 
				arguments: {}
				getEnabled: #enabled
				getLabel: nil
				help: 'Advanced dialog for ' translated, self name translated) label: self name, '...';
				 yourself]! !

!SystemSettingNode methodsFor: '*system-settings-browser' stamp: 'alain.plantec 3/24/2009 20:55'!
openDialog
	(Smalltalk at: self dialog asSymbol) open! !

Object subclass: #SettingFilter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

!SettingFilter commentStamp: 'alain.plantec 3/25/2009 22:36' prior: 0!
A SettingFilter is a filter wich is used by a SettingTree in order to filter viewed nodes. 
A particular filter must redefine #keepHandler: method which return true if the argument handler
is to be kept.

Instance Variables
!

!SettingFilter methodsFor: 'filtering' stamp: 'alain.plantec 3/25/2009 22:39'!
keepHandler: aSettingHandler 
	^ false! !

SettingFilter subclass: #SettingPackageFilter
	instanceVariableNames: 'packages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

!SettingPackageFilter commentStamp: 'alain.plantec 3/25/2009 22:38' prior: 0!
A SettingPackageFilter is SettingFilter which keeps only handlers from a given package

Instance Variables
	packages:		<Object>

packages
	- xxxxx
!

!SettingPackageFilter methodsFor: 'filtering' stamp: 'alain.plantec 3/25/2009 22:39'!
keepHandler: aSettingHandler 
	^ self packages includes: aSettingHandler package! !

!SettingPackageFilter methodsFor: 'accessing' stamp: 'alain.plantec 3/16/2009 23:00'!
packages
	"Answer the value of packages"

	^ packages! !

!SettingPackageFilter methodsFor: 'accessing' stamp: 'alain.plantec 3/16/2009 23:01'!
packages: aCollectionOfPackages
	"Set the value of packages"

	packages := aCollectionOfPackages! !

SettingFilter subclass: #SettingSearchTokenFilter
	instanceVariableNames: 'token'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

!SettingSearchTokenFilter commentStamp: 'alain.plantec 3/25/2009 22:39' prior: 0!
A SettingSearchTokenFilter is filter which keeps only handler with a given token.


Instance Variables
	token:		<Object>

token
	- xxxxx
!

!SettingSearchTokenFilter methodsFor: 'filtering' stamp: 'alain.plantec 3/25/2009 22:41'!
keepHandler: aSettingHandler 
	^ (({aSettingHandler methodClass name asUppercase. aSettingHandler selector asUppercase}
			collect: [:e | e
					ifNil: ['']])
			includesSubstringAnywhere: self token asUppercase)
		or: [self keepValue: aSettingHandler value]! !

!SettingSearchTokenFilter methodsFor: 'filtering' stamp: 'alain.plantec 3/25/2009 22:40'!
keepValue: aSettingNode
	^ (({aSettingNode name asUppercase. aSettingNode description asUppercase}
				collect: [:e | e ifNil: ['']])
				includesSubstringAnywhere: self token asUppercase)
! !

!SettingSearchTokenFilter methodsFor: 'accessing' stamp: 'alain.plantec 3/16/2009 22:51'!
token
	"Answer the value of token"

	^ token! !

!SettingSearchTokenFilter methodsFor: 'accessing' stamp: 'alain.plantec 3/16/2009 22:51'!
token: aString
	"Set the value of token"

	token := aString! !

Object subclass: #SettingManager
	instanceVariableNames: ''
	classVariableNames: 'Current'
	poolDictionaries: ''
	category: 'System-Settings-Core'!

!SettingManager classSide methodsFor: 'accessing' stamp: 'alain.plantec 3/16/2009 12:27'!
current
	"Answer the current manager."

	^Current ifNil: [Current := SettingManager new]! !

!SettingManager classSide methodsFor: 'instance creation' stamp: 'alain.plantec 3/17/2009 09:31'!
newFixed: aName
	^ self current newFixed: aName! !

!SettingManager classSide methodsFor: 'instance creation' stamp: 'alain.plantec 3/16/2009 13:33'!
newFixedMultiple: aName
	^ self current newFixedMultiple: aName! !

!SettingManager classSide methodsFor: 'instance creation' stamp: 'alain.plantec 3/24/2009 21:08'!
newMenu: aName 	
	^ self current newMenu: aName ! !

!SettingManager classSide methodsFor: 'instance creation' stamp: 'alain.plantec 3/25/2009 00:12'!
newMenuSiblings
	^ self current newMenuSiblings! !

!SettingManager classSide methodsFor: 'instance creation' stamp: 'alain.plantec 3/26/2009 11:42'!
newMenuSiblings: aName
	^ self current newMenuSiblings: aName
! !

!SettingManager classSide methodsFor: 'instance creation' stamp: 'alain.plantec 3/16/2009 13:32'!
newMultiple: aName
	^ self current newMultiple: aName! !

!SettingManager classSide methodsFor: 'instance creation' stamp: 'alain.plantec 3/16/2009 13:25'!
newNode: aName
	^ self current newNode: aName! !

!SettingManager classSide methodsFor: 'instance creation' stamp: 'alain.plantec 3/16/2009 13:30'!
newRange: aName
	^ self current newRange: aName! !

!SettingManager classSide methodsFor: 'instance creation' stamp: 'alain.plantec 3/16/2009 13:22'!
newSetting: aName
	^ self current newSetting: aName! !

!SettingManager methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 09:22'!
newFixed: aName 
	^ FixedSettingValue new name: aName! !

!SettingManager methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 09:22'!
newFixedMultiple: aName 
	^ FixedMultipleSettingValue new name: aName! !

!SettingManager methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 19:02'!
newMenu: aName 
	^ MenuElement new name: aName! !

!SettingManager methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 00:12'!
newMenuSiblings
	^ MenuSiblings new ! !

!SettingManager methodsFor: 'accessing' stamp: 'alain.plantec 3/26/2009 11:42'!
newMenuSiblings: aName
	^ self newMenuSiblings name: aName! !

!SettingManager methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 09:22'!
newMultiple: aName 
	^ MultipleSettingValue new name: aName! !

!SettingManager methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 19:08'!
newNode: aName  
	^ SystemSettingNode new name: aName! !

!SettingManager methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 09:22'!
newRange: aName 
	^ RangeSettingValue new name: aName! !

!SettingManager methodsFor: 'accessing' stamp: 'alain.plantec 3/23/2009 09:22'!
newSetting: aName 
	^ SettingValue new name: aName! !

Object subclass: #SettingMenuAssembler
	instanceVariableNames: 'treeBuilder collector menuTitle discoveredMenu'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Menu-Assembler'!

!SettingMenuAssembler methodsFor: 'menu building' stamp: 'alain.plantec 3/25/2009 18:58'!
buildMenu
	| treeRoots menu |
	treeRoots := self treeBuilder buildTree. 
	menu := MenuMorph new defaultTarget: ToolSet default.
	menu title: self menuTitle.
	menu addStayUpItem.
	treeRoots do: [:c | c menuItemIn: menu].
	^ menu
	! !

!SettingMenuAssembler methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 23:33'!
collector
	^ collector
		ifNil: [collector := (PragmaCollector requestor: self) reset]! !

!SettingMenuAssembler methodsFor: 'menu building' stamp: 'alain.plantec 3/25/2009 18:58'!
discoveredMenu
	^ discoveredMenu ifNil: [discoveredMenu := self buildMenu]
! !

!SettingMenuAssembler methodsFor: 'menu building' stamp: 'alain.plantec 3/25/2009 18:56'!
doPopUpMenu
	self discoveredMenu popUpEvent: nil in: World
! !

!SettingMenuAssembler methodsFor: 'testing' stamp: 'alain.plantec 3/24/2009 23:48'!
keepPragma: aPragma
	^ self subclassresponsibility ! !

!SettingMenuAssembler methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 18:25'!
menuTitle
	^ menuTitle! !

!SettingMenuAssembler methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 18:26'!
menuTitle: aTitle
	menuTitle := aTitle! !

!SettingMenuAssembler methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 22:10'!
nodeClass
	^ SystemMenuTreeNode! !

!SettingMenuAssembler methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 23:05'!
pragmaHandlerClass
	^ SettingHandler! !

!SettingMenuAssembler methodsFor: 'dependents access' stamp: 'alain.plantec 3/24/2009 23:37'!
release
	collector release.
	treeBuilder release.
	treeBuilder := nil.
	collector := nil.
	super release.! !

!SettingMenuAssembler methodsFor: 'accessing' stamp: 'alain.plantec 3/25/2009 10:16'!
treeBuilder
	^ treeBuilder ifNil: [treeBuilder := SettingMenuTreeBuilder new requestor: self]! !

SettingMenuAssembler subclass: #WorldMenuAssembler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Menu-Assembler'!

!WorldMenuAssembler methodsFor: 'testing' stamp: 'alain.plantec 3/25/2009 20:06'!
initialize
	super initialize.
	menuTitle := 'World'! !

!WorldMenuAssembler methodsFor: 'testing' stamp: 'alain.plantec 3/24/2009 23:47'!
keepPragma: aPragma
	^ aPragma keyword = #worldMenu! !

Object subclass: #SettingSettings
	instanceVariableNames: ''
	classVariableNames: 'StyleNameClassSuffix UserStylePackageNamePrefix'
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

!SettingSettings classSide methodsFor: 'setting' stamp: 'alain.plantec 3/19/2009 11:35'!
styleNameClassSuffix
	<internalSetting>
	^ StyleNameClassSuffix
		ifNil: [StyleNameClassSuffix := (SettingManager newSetting: 'User style classname suffix') description: 'A setting style is stored as a class which name is the style name suffixed with the value of this setting.
As an example, if the value of this setting is "SettingStyle" then, for a style named "Favorite", the corresponding style class name is "FavoriteSettingStyle".';
						 default: 'SettingStyle']! !

!SettingSettings classSide methodsFor: 'setting' stamp: 'alain.plantec 3/19/2009 17:05'!
userStylePackageNamePrefix
	<internalSetting>
	^ UserStylePackageNamePrefix
		ifNil: [UserStylePackageNamePrefix := (SettingManager newSetting: 'User style package') description: 'The name of the package to update or create with user defined styles';
						 default: 'UserDefinedSettings']! !

Object subclass: #SettingStyle
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Style'!

SettingStyle subclass: #DefaultSettingStyle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Style'!

!DefaultSettingStyle class methodsFor: 'accessing' stamp: 'alain.plantec 3/19/2009 18:33'!
styleName
	^ 'Default' translated! !

!DefaultSettingStyle methodsFor: 'loading' stamp: 'alain.plantec 3/23/2009 09:26'!
load
FontsSettings freeTypeCacheSize value:  5000.
FontsSettings standardFont value:  (LogicalFont familyName: 'DejaVu Sans' fallbackFamilyNames: nil pointSize: 12 stretchValue: 5 weightValue: 400 slantValue: 0). 
FontsSettings hintingSetting value:  nil.
FontsSettings codeFont value:  (LogicalFont familyName: 'DejaVu Sans' fallbackFamilyNames: nil pointSize: 12 stretchValue: 5 weightValue: 400 slantValue: 0).
FontsSettings listFont value:  (LogicalFont familyName: 'DejaVu Sans' fallbackFamilyNames: nil pointSize: 12 stretchValue: 5 weightValue: 400 slantValue: 0).
FontsSettings xFont value:  (LogicalFont familyName: 'DejaVu Sans' fallbackFamilyNames: nil pointSize: 12 stretchValue: 5 weightValue: 400 slantValue: 0).
FontsSettings glyphContrast value:  50.
FontsSettings buttonFont value:  (LogicalFont familyName: 'DejaVu Sans' fallbackFamilyNames: nil pointSize: 12 stretchValue: 5 weightValue: 400 slantValue: 0).
MorphicSettings showBoundsInHalo value:  false.
MorphicSettings haloEnabled value:  false.
MorphicSettings haloTheme value:  #Classic.
MorphicSettings maintainHalos value:  false.
UISettings newbyMode value:  true.
UISettings themeSetting2 value:  UIThemeWatery2.
UISettings desktopColor value:  (Color r: 0.0 g: 1.0 b: 0.0).
UISettings themeSetting3 value:  UIThemeWatery2.
UISettings gradientButtonLook value:  true.
UISettings gradientColor value:  (TranslucentColor r: 1.0 g: 0.0 b: 0.0 alpha: 0.498).
UISettings themeSetting value:  UIThemeWatery2.
UISettings smartUpdating value:  true.
! !

!SettingStyle classSide methodsFor: 'accessing' stamp: 'alain.plantec 3/19/2009 13:27'!
styleName
	^ self subclassresponsibility ! !

!SettingStyle methodsFor: 'loading' stamp: 'alain.plantec 3/19/2009 08:24'!
load
	^ self subclassResponsibility! !

Object subclass: #SettingTreeBuilder
	instanceVariableNames: 'requestor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Browser'!

SettingTreeBuilder subclass: #SettingMenuTreeBuilder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'System-Settings-Menu-Browser'!

!SettingMenuTreeBuilder methodsFor: 'tree building' stamp: 'alain.plantec 3/26/2009 11:17'!
orderedContentsFrom: aCollection 
	^ (aCollection asSortedCollection: [:a :b | a item value order < b item value order]) asOrderedCollection 
! !

!SettingTreeBuilder methodsFor: 'tree building' stamp: 'alain.plantec 3/25/2009 21:10'!
buildTree
		| r |
		r := self orderedContentsFrom: ((self collector select: [:p | p value parent isNil])
		 collect: [:d | self nodeClass with: d model: self]).
		r do: [:n | n buildContents].
		^ self withUnclassifiedIn: r asOrderedCollection
	! !

!SettingTreeBuilder methodsFor: 'querying' stamp: 'alain.plantec 3/24/2009 21:49'!
childrenOf: aSettingHandler
	^ (self nonRoots select: [:p | p value notNil]) 
			select: [:p | p value parent = aSettingHandler selector]! !

!SettingTreeBuilder methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 21:40'!
collector
		^ requestor collector! !

!SettingTreeBuilder methodsFor: 'querying' stamp: 'alain.plantec 3/24/2009 21:43'!
hasUnclassified
	^ (self nonRoots detect: [:p | self collector noneSatisfy: [:pp | pp selector = p value parent]] ifNone: []) notNil! !

!SettingTreeBuilder methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 21:40'!
nodeClass 
	^ requestor nodeClass! !

!SettingTreeBuilder methodsFor: 'querying' stamp: 'alain.plantec 3/24/2009 21:49'!
nonRoots
	^ self collector reject: [:p | p value parent isNil]
! !

!SettingTreeBuilder methodsFor: 'tree building' stamp: 'alain.plantec 3/25/2009 21:09'!
orderedContentsFrom: aCollection
		^ (aCollection asSortedCollection: [:a :b | a item value name < b item value name]) asOrderedCollection 
! !

!SettingTreeBuilder methodsFor: 'dependents access' stamp: 'alain.plantec 3/24/2009 22:56'!
release
	requestor := nil.
	super release! !

!SettingTreeBuilder methodsFor: 'accessing' stamp: 'alain.plantec 3/24/2009 21:53'!
requestor: aRequestor
	requestor := aRequestor! !

!SettingTreeBuilder methodsFor: 'querying' stamp: 'alain.plantec 3/24/2009 21:49'!
unclassified
	^ self nonRoots select: [:p | self collector noneSatisfy: [:pp | (self childrenOf: pp) includes: p]]! !

!SettingTreeBuilder methodsFor: 'tree building' stamp: 'alain.plantec 3/24/2009 22:08'!
withUnclassifiedIn: aCollectionOfNodes
	self hasUnclassified ifTrue: [aCollectionOfNodes addFirst: (SystemSettingUnclassifiedTreeNode model: self)].
	^ aCollectionOfNodes
! !
